#ifndef _ADRTIME_H
#define _ADRTIME_H

struct frame;
class CAdrTime  
{
public:
	CAdrTime();
	virtual ~CAdrTime();

	BOOL Init(FileSys* _input_file, int pos);
	void Release();

	DWORD ToAddress(int nTime);
	int ToTime(DWORD dwAdr);

private:
	struct AdrTimeData
	{
		DWORD dwAdr;
		int nTime;
		AdrTimeData() : dwAdr((DWORD)-1), nTime(-1) {}
		AdrTimeData(DWORD dw, int n) : dwAdr(dw), nTime(n) {}
		static int CompAdr(const AdrTimeData* p1, const AdrTimeData* p2);
		static int CompTime(const AdrTimeData* p1, const AdrTimeData* p2);
	};

private:
	AdrTimeData* m_pData;
	int m_nNumData;
	int m_nMaxData;

	double m_dTime;
	FileSys*	input_file;

	double GetFrameTime(const frame& fr);
	BOOL GetFrame(frame& fr);
	int ReadFrame(frame& fr);
	BOOL CheckHeader(DWORD header);
	DWORD GetFilePtr();

	BOOL AddData(DWORD dw, double n);


	BOOL ProcessOneFrame();
};

#endif
