
//
//  ėp֐
//
//  Written by Otachan
//  http://www.aikis.or.jp/~otachan/
//

#define	STRICT

#include <windows.h>
#include <mbctype.h>

#include "CommonFunc.h"

bool
CutPathFileName(const char* FullName, char* FileNamePath, char* FileName)
{
	unsigned char	Str;
	int		cnt = 0;
	int		BackSlashCnt = -1;
	bool	Kanji = false;

	while((Str = *(FullName + cnt)) != '\0') {
		if(!Kanji) {
			if(_ismbblead(Str)) {
				Kanji = true;
			} else {
				if((Str == '\\') || (Str == '/')) {
					BackSlashCnt = cnt;
				}
			}
		} else {
			Kanji = false;
		}
		cnt++;
	}

	if(FileNamePath) {
		memcpy(FileNamePath, FullName, BackSlashCnt + 1);
		*(FileNamePath + 1 + BackSlashCnt) = '\0';
	}

	if(FileName) {
		strcpy(FileName, FullName + 1 + BackSlashCnt);
	}

	return BackSlashCnt != -1;
}

void
CutFileNameExt(const char* FullName, char* FileName, char* FileExt)
{
	char	Str;
	int		FullNameLen = strlen(FullName);
	int		ExtCnt = FullNameLen - 1;

	while(true) {
		Str = *(FullName + ExtCnt);
		if((ExtCnt == 0) || (Str == '.') || (Str == '\\') || (Str == '/')) break;
		ExtCnt--;
	}

	if(Str != '.') ExtCnt = FullNameLen;

	if(FileName) {
		memcpy(FileName, FullName, ExtCnt);
		*(FileName + ExtCnt) = '\0';
	}

	if(FileExt) {
		if(Str == '.') {
			strcpy(FileExt, FullName + ExtCnt + 1);
		} else {
			*FileExt = '\0';
		}
	}
}

char*
KanjiStrncpy(char* OutBuff, char* InBuff, int Len)
{
	char*	RetOutBuff = OutBuff;
	unsigned char	Str;
	bool	Kanji = false;

	for(int cnt = 0; (cnt < Len) && ((Str = *(InBuff + cnt)) != '\0'); cnt++) {
		if(!Kanji) {
			if(_ismbblead(Str)) {
				Kanji = true;
			}
		} else {
			Kanji = false;
		}
		*OutBuff++ = Str;
	}

	if(Kanji) OutBuff--;

	*OutBuff = '\0';

	return RetOutBuff;
}

char*
WideToMultiStrcpy(char* OutBuff, WCHAR* InBuff,
						UINT OutBuffSize, UINT InBuffSize,
						bool UseBOM, bool BigEndian)
{
	if(UseBOM && (InBuffSize >= 2)) {
		if((*reinterpret_cast<unsigned char*>(InBuff) == 0xfe) &&
					(*(reinterpret_cast<unsigned char*>(InBuff) + 1) == 0xff)) {
							// rbOGfBA
			InBuff++;
			InBuffSize -= 2;
			BigEndian = true;
		} else if((*reinterpret_cast<unsigned char*>(InBuff) == 0xff) &&
					(*(reinterpret_cast<unsigned char*>(InBuff) + 1) == 0xfe)) {
							// gGfBA
			InBuff++;
			InBuffSize -= 2;
			BigEndian = false;
		}
	}

	unsigned char*	InWorkBuff = new unsigned char[InBuffSize + 2];

	if(BigEndian) {
		unsigned char*	InBuffPnt = reinterpret_cast<unsigned char*>(InBuff);
		unsigned char*	InWorkBuffPnt = InWorkBuff;
		UINT	MaxLoop = InBuffSize / 2;

		for(UINT Idx = 0; Idx < MaxLoop; Idx++) {
			*InWorkBuffPnt++ = *(InBuffPnt + 1);
			*InWorkBuffPnt++ = *InBuffPnt;

			InBuffPnt += 2;
		}

		*InWorkBuffPnt++ = 0;
		*InWorkBuffPnt   = 0;
	} else {
		memcpy(InWorkBuff, InBuff, InBuffSize);
		*(InWorkBuff + InBuffSize)     = 0;
		*(InWorkBuff + InBuffSize + 1) = 0;
	}

	int		OutWorkBuffSize = ::WideCharToMultiByte(CP_ACP, 0,
										reinterpret_cast<WCHAR*>(InWorkBuff),
										-1, NULL, 0, NULL, NULL);

	if(OutWorkBuffSize > 0) {
		char*	OutWorkBuff = new char[OutWorkBuffSize];

		::WideCharToMultiByte(CP_ACP, 0,
				reinterpret_cast<WCHAR*>(InWorkBuff),
				-1, OutWorkBuff, OutWorkBuffSize, NULL, NULL);
		KanjiStrncpy(OutBuff, OutWorkBuff, OutBuffSize - 1);

		delete[] OutWorkBuff;
	} else {
		*OutBuff = '\0';
	}

	delete[] InWorkBuff;

	return OutBuff;
}

char*
UTF8ToMultiStrcpy(char* OutBuff, unsigned char* InBuff,
						UINT OutBuffSize, UINT InBuffSize)
{
	unsigned char*	InWorkBuff = new unsigned char[InBuffSize * 2];
	unsigned char*	InWorkBuffPnt = InWorkBuff;
	UINT	UnicodeSize = 0;

	for(UINT Idx = 0; Idx < InBuffSize;) {
		unsigned char	Str1 = *InBuff++;

		if(Str1 < 0xc0U) {
			if(Str1 == 0) break;
			if((InBuffSize - Idx) >= 2) {
				*InWorkBuffPnt++ = Str1;
				*InWorkBuffPnt++ = 0;
				Idx++;
			} else {
				break;
			}
		} else if(Str1 < 0xe0U) {
			if((InBuffSize - Idx) >= 2) {
				*InWorkBuffPnt++ = (Str1 << 6) + (*InBuff++ & 0x3fU);
				*InWorkBuffPnt++ = (Str1 & 0x1fU) >> 2;
				Idx += 2;
			} else {
				break;
			}
		} else {
			if((InBuffSize - Idx) >= 3) {
				unsigned char	Str2 = *InBuff++;

				*InWorkBuffPnt++ = (Str2 << 6) + (*InBuff++ & 0x3fU);
				*InWorkBuffPnt++ = (Str1 << 4) + ((Str2 & 0x3fU) >> 2);
				Idx += 3;
			} else {
				break;
			}
		}

		UnicodeSize += 2;
	}

	WideToMultiStrcpy(OutBuff, reinterpret_cast<WCHAR*>(InWorkBuff),
							OutBuffSize, UnicodeSize, false, false);

	delete[] InWorkBuff;

	return OutBuff;
}

UINT
WideStrSize(WCHAR* InBuff, const UINT MaxSize)
{
	unsigned char*	InBuffPnt = reinterpret_cast<unsigned char*>(InBuff);
	bool	ZeroBits = false;
	UINT	Size;

	for(Size = 0; Size < MaxSize; Size++) {
		unsigned char	Str = *InBuffPnt++;

		if(Str == 0) {
			if(ZeroBits) {
				Size++;
				break;
			}
			ZeroBits = true;
		} else {
			ZeroBits = false;
		}
	}

	return Size;
}

