// ConfigDialog.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "in_mpg123d.h"
#include "In_mpg123dParam.h"
#include "In_mpg123dPropertySheet.h"
#include "ConfigDialog.h"
#include ".\configdialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static const int	List_Bps[] =
{16, 24, 32, -32, -64};

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog _CAO

IMPLEMENT_DYNCREATE(CConfigDialog, CPropertyPage)

CConfigDialog::CConfigDialog()
	: CPropertyPage(CConfigDialog::IDD)
{
	//{{AFX_DATA_INIT(CConfigDialog)
	m_bReverse = FALSE;
	m_bDispAvg = FALSE;
	m_bEnable = FALSE;
	m_bForce = FALSE;
	m_bInvert = FALSE;
	m_bSupZero = FALSE;
	m_bAltVolume = FALSE;
	m_bFullBuffering = FALSE;
	//}}AFX_DATA_INIT
}

void CConfigDialog::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigDialog)
	DDX_Control(pDX, IDC_COMBO_OUTPUTBPS, m_comboOutputBps);
	DDX_Control(pDX, IDC_COMBO_DECODER_PRIORITY, m_comboDecodePriority);
	DDX_Check(pDX, IDC_CH_REV, m_bReverse);
	DDX_Check(pDX, IDC_CH_DISPAVG, m_bDispAvg);
	DDX_Check(pDX, IDC_CH_ENABLE, m_bEnable);
	DDX_Check(pDX, IDC_CH_FORCE, m_bForce);
	DDX_Check(pDX, IDC_CH_INVERT, m_bInvert);
	DDX_Check(pDX, IDC_CH_SUPZERO, m_bSupZero);
	DDX_Check(pDX, IDC_CH_VOLUME, m_bAltVolume);
	DDX_Check(pDX, IDC_CH_FULLBUFFERING, m_bFullBuffering);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConfigDialog, CPropertyPage)
	//{{AFX_MSG_MAP(CConfigDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_OUTPUTBPS, OnCbnSelchangeComboOutputbps)
	ON_CBN_SELCHANGE(IDC_COMBO_DECODER_PRIORITY, OnSelchangeComboDecoderPriority)
	ON_BN_CLICKED(IDC_CH_ENABLE, OnChEnable)
	ON_BN_CLICKED(IDC_CH_SUPZERO, OnChSupzero)
	ON_BN_CLICKED(IDC_CH_FORCE, OnChForce)
	ON_BN_CLICKED(IDC_CH_DISPAVG, OnChDispavg)
	ON_BN_CLICKED(IDC_CH_REV, OnChRev)
	ON_BN_CLICKED(IDC_CH_INVERT, OnChInvert)
	ON_BN_CLICKED(IDC_CH_VOLUME, OnChVolume)
	ON_BN_CLICKED(IDC_CH_FULLBUFFERING, OnChFullBuffering)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigDialog bZ[W nh

void CConfigDialog::OnOK() 
{
	BOOL bFlag = FALSE;

	UpdateData();

	if(pr->m_nOutputBps != List_Bps[m_comboOutputBps.GetCurSel()]) {
		pr->m_nOutputBps = List_Bps[m_comboOutputBps.GetCurSel()];
		bFlag = TRUE;
	}

	if(pr->m_nDecodeThreadPriority != m_comboDecodePriority.GetCurSel()) {
		pr->m_nDecodeThreadPriority = m_comboDecodePriority.GetCurSel();
		bFlag = TRUE;
	}

	pr->m_bEnable = m_bEnable;
	pr->m_bSupZero = m_bSupZero;
	pr->m_bForce = m_bForce;
	pr->m_bDispAvg = m_bDispAvg;
	pr->m_bReverse = m_bReverse;
	pr->m_bInvert = m_bInvert;
	pr->m_bAltVolume = m_bAltVolume;
	pr->m_bFullBuffering = m_bFullBuffering;

	pr->m_bPostProc = m_bReverse || m_bInvert || m_bAltVolume;

	/* activeIndex 擾 */
	CIn_mpg123dPropertySheet* pSheet = (CIn_mpg123dPropertySheet*)GetParent();
	pr->m_nStartPage = pSheet->GetActiveIndex();
	pSheet->ReflectSetting(bFlag);

	CPropertyPage::OnOK();
}

void CConfigDialog::OnCancel() 
{
	// TODO: ̈ʒuɓʂȌ㏈ǉĂB
	
	CPropertyPage::OnCancel();
}

void CConfigDialog::SetParam()
{
	m_bEnable = pr->m_bEnable;
	m_bSupZero = pr->m_bSupZero;
	m_bForce = pr->m_bForce;
	m_bDispAvg = pr->m_bDispAvg;
	m_bReverse = pr->m_bReverse;
	m_bInvert = pr->m_bInvert;
	m_bAltVolume = pr->m_bAltVolume;
	m_bFullBuffering = pr->m_bFullBuffering;
}

void CConfigDialog::OnCbnSelchangeComboOutputbps()
{
	// TODO : ɃRg[ʒmnh R[hǉ܂B
	SetModified();
}

void CConfigDialog::OnSelchangeComboDecoderPriority() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChEnable() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChSupzero() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChForce() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChDispavg() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChRev() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChInvert() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChVolume() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

void CConfigDialog::OnChFullBuffering() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	SetModified();
	
}

BOOL CConfigDialog::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	// TODO: ̈ʒuɏ̕⑫ǉĂ

	for(int Idx = 0; Idx < 5; Idx++) {
		if(List_Bps[Idx] == pr->m_nOutputBps) {
			m_comboOutputBps.SetCurSel(Idx);
			break;
		}
	}

	m_comboDecodePriority.SetCurSel(pr->m_nDecodeThreadPriority);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}
