// ICYInfo.cpp: CICYInfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "in_mpg123d.h"
#include "ICYInfo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

void UpdateWinampDisplay();
UINT ReadStream(char* buf, UINT nCount);
void UpdateUDPSocket(CString server, UINT nPort);

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CICYInfo::CICYInfo()
{
	Init();
}

CICYInfo::~CICYInfo()
{
	// begin pl4 by YunaSoft
	DeleteHeader();
	// end pl4
}

void CICYInfo::Init()
{

	// initialize
	m_name = "";
	m_genre = "";
	m_url = "";
	m_metaint = 0;
	m_pub = 0;
	m_br = 0;
	m_udpport = 0;
	m_header = NULL;
	m_received = 0;
	m_server = "";

}

int CICYInfo::ParseIcyInfo(char *src, int i)
{
	char *p, *pEnd, *str;
	int num;
	int ret;

	src += 12;

	// end check
	p = strstr(src, "\r\n\r\n");
	if (p) {    
		*(p + 3) = 0;
		ret = (p + 4) - src + 12;
	} else {
		p = strstr(src, "\n\n");
		if (p) {    
			*(p + 1) = 0;
			ret = (p + 2) - src + 12;
		} else {
			// I[Ȃ̂Parse͑ł؂
			return 0;
		}
	}

    // icy-name
	if(p = strstr(src, "icy-name")) {
		p += strlen("icy-name:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_name = str;
		delete str;
    }
	// icy-genre
	if(p = strstr(src, "icy-genre")) {
		p += strlen("icy-genre:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_genre = str;
		delete str;
	}
	// icy-url
	if(p = strstr(src, "icy-url")) {
        p += strlen("icy-url:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_url = str;
		delete str;
    }
	// icy-metaint
	if(p = strstr(src, "icy-metaint")) {
        p += strlen("icy-metaint:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_metaint = atoi(str);
		delete str;
    } else {
		// w肪Ƃ͖I-1Ă
		m_metaint = -1;
	}
	// icy-pub
	if(p = strstr(src, "icy-pub")) {
        p += strlen("icy-pub:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_pub = atoi(str);
		delete str;
    }
	// icy-br
	if(p = strstr(src, "icy-br")) {
        p += strlen("icy-br:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_br = atoi(str);
		delete str;
    }

	// x-audiocast-udpport
	if((m_udpport) &&
		(p = strstr(src, "x-audiocast-udpport"))) {
		UINT oldudpport = m_udpport;
        p += strlen("x-audiocast-udpport:");
		// \r\nŏI[Ă͂
		pEnd = strstr(p, "\r\n");
		num = pEnd - p;
		str = new char [num + 1];
		strncpy(str, p, num);
		*(str + num) = NULL;
		m_udpport = atoi(str);
		delete str;

		// ύXĐڑ
		if(oldudpport != m_udpport) {
			::UpdateUDPSocket(m_server, m_udpport);
		}
	} else {
		// w肪Ƃ͖I-1Ă
		m_udpport = -1;
	}

	return ret;
}

#define READUNIT 1024

UINT CICYInfo::GetICYInfo(char *lpBuf, char* buf, UINT len)
{

	int len2, len3, num, metaStrSize;
	int start;
	char *p, *pMeta, *pEnd;
	char *metaStr, *str;
	int headermaxsize = 4096;

	// m_metaint = 0 Ȃ璲ׂ
	if (!m_metaint) {
		if (!strncmp(buf, "ICY 200 OK", 10)) {
			// wb_icyheaderɃRs[
			if(m_header) {
				delete m_header;
				m_header = NULL;
			}
			m_header = new char [headermaxsize];
			strncpy(m_header, buf, len);
			*(m_header + len) = NULL;

			// wb_̃TCYԂBwb_I[Ȃ0
			start = ParseIcyInfo(m_header, len);
			if (start > 0) {
				// svȂ̂ō폜
				delete m_header;
				m_header = NULL;
				// wb_TCYreceivedɂȂ
				m_received = len - start;
				// wb_ret
				memcpy(lpBuf, buf + start, m_received);
				return m_received;
			}
		} else {
			// wb_̓rǂׂ
			if(m_header) {
				len2 = strlen(m_header);
				if(len2 > (headermaxsize - READUNIT)) {
					// wb_̃p[Xł؂
					// ߂(^^;
					delete m_header;
					m_header = NULL;
				} else {
					// wb_strcat
					strncat(m_header, buf, len);
					*(m_header + len) = NULL;
					// Parse
					start = ParseIcyInfo(m_header, strlen(m_header));
					if (start > 0) {
						// wb_TCYmetaintɂȂ
						m_received = len - (start - len2);
						delete m_header;
						m_header = NULL;
					}
				}
			}
		}
	} else {
		// icy.m_metaint = -1 Ȃ lpBufɃRs[ret
		if(m_metaint < 0) {
			memcpy(lpBuf, buf, len);
			return len;
		}

		// MoCg
		m_received += len;
		//  received  icy.m_metaint Ȃ
		// ̒Stringߍ܂Ă̂Ŏo
		if(m_received > m_metaint) {
			len2 = m_received - m_metaint;
			pMeta = buf + (len - len2);

			// icy.m_metaint oCgcharonew
			metaStrSize = *pMeta * 16;
			if(metaStrSize) {
				// StringׂēĂȂȂ
				if((pMeta + 1 + (*pMeta * 16)) > (buf + len)) {
					// Ȃǂ݂
					len3 = ::ReadStream(buf + len, (pMeta + 1 + (*pMeta * 16)) - (buf + len));
					len += len3;
					len2 += len3;
					m_received += len3;
				}
				metaStr = new char[metaStrSize + 1];
				memcpy(metaStr, pMeta + 1, metaStrSize);
	
				if (p = strstr(metaStr, "StreamTitle=")) {
					p += strlen("StreamTitle='");
					pEnd = strchr(p, '\'');
					num = pEnd - p;
					str = new char [num + 1];
					strncpy(str, p, num);
					*(str + num) = NULL;
					m_title = str;
					delete str;
					::UpdateWinampDisplay();
				}
				delete metaStr;
			}

			// metaStr̂lpBufɃRs[
			memcpy(lpBuf, buf, (len - len2));
			memcpy(lpBuf + (len - len2), pMeta + metaStrSize + 1, len2 - (metaStrSize + 1));
			m_received = len2 - (metaStrSize + 1);
			return len - (metaStrSize + 1);
		}
	}

	memcpy(lpBuf, buf, len);
	return len;

}

void CICYInfo::DeleteHeader(void)
{
	if(m_header) {
		delete m_header;
		m_header = NULL;
	}
}
