// In_mpg123dParam.cpp: CIn_mpg123dParam NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "in_mpg123d.h"

#include "In_mpg123dParam.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CIn_mpg123dParam::CIn_mpg123dParam()
{

	// Initialize members

	m_nBufferLength		= 256;
	m_bProxy			= FALSE;
	m_strProxy			= "";
	m_bSaveStream		= FALSE;
	m_strSaveStream		= "";
	m_bTitleStreaming	= TRUE;
	m_bTitleStreamingDecode = TRUE;
	m_bTitleStreamingUDP = TRUE;
	m_strTitleStreamingFormat = "%1 (%2)";

	m_strID3Format = "%1 - %2";
	m_strSIFFormat = "%IART - %INAM";

	m_bEnable	= TRUE;
	m_bSupZero	= FALSE;
	m_bForce	= FALSE;
	m_bDispAvg	= TRUE;
	m_bAltVolume= FALSE;
	m_bReverse	= FALSE;
	m_bInvert	= FALSE;
	m_bFullBuffering = FALSE;
	m_nOutputBps = 16;

	m_nUseMP3	= FALSE;
	m_nUseRMP	= FALSE;
	m_nUseWAV	= FALSE;
	m_strAdditionalExtension = "";

	m_nVolume = 255;
	m_nPan = 0;
	m_nStartPage = 0;

	m_nTimeOut = 10;
	m_nReceiveThreadPriority = 2;
	m_nDecodeThreadPriority = 2 /* THREAD_PRIORITY_HIGHEST */;
	m_nInetReadThreadPriority = 2;
}

CIn_mpg123dParam::~CIn_mpg123dParam()
{
	WriteProfile();
}

void CIn_mpg123dParam::GetIniFn(HMODULE hDllInstance)
{
	// makes a .ini file in the winamp directory named "plugin.ini"
	char *p;

	GetModuleFileName(hDllInstance, ini_file, MAX_PATH);
	p=ini_file+strlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	strcat(ini_file,"plugin.ini");

}

void CIn_mpg123dParam::GetProfile(void)
{

	char buf[MAX_PATH];
	char szAppName[] = "Shibatch mpg123";

	m_bEnable   = GetPrivateProfileInt(szAppName,"Enable" ,  1,ini_file);
	m_bSupZero  = GetPrivateProfileInt(szAppName,"SupZero",  0,ini_file);
	m_bForce    = GetPrivateProfileInt(szAppName,"Force"  ,  0,ini_file);
	m_bDispAvg  = GetPrivateProfileInt(szAppName,"DispAvg",  1,ini_file);
	m_bAltVolume= GetPrivateProfileInt(szAppName,"Volume" ,  0,ini_file);
	m_bReverse  = GetPrivateProfileInt(szAppName,"Reverse",  0,ini_file);
	m_bInvert   = GetPrivateProfileInt(szAppName,"Invert" ,  0,ini_file);
	m_bFullBuffering = GetPrivateProfileInt(szAppName, "FullBuffering", 0, ini_file);
	m_nOutputBps = GetPrivateProfileInt(szAppName,"OutputFormat", 16,ini_file);

	if(m_nOutputBps == 64) m_nOutputBps = -64;

	m_bPostProc = m_bReverse || m_bInvert || m_bAltVolume;

	m_nBufferLength  = GetPrivateProfileInt(szAppName,"StrBuf" ,256,ini_file);

	m_nVolume     = GetPrivateProfileInt(szAppName,"XVolume",255,ini_file);
	m_nPan        = GetPrivateProfileInt(szAppName,"XPan"   ,  0,ini_file);

	m_nReceiveThreadPriority = GetPrivateProfileInt(szAppName,"ReceivePriority",2,ini_file);
	m_nDecodeThreadPriority = GetPrivateProfileInt(szAppName,"DecodePriority"   ,  2,ini_file);
	m_nInetReadThreadPriority = GetPrivateProfileInt(szAppName,"InetReadPriority"   ,  2,ini_file);

	m_bProxy   = GetPrivateProfileInt(szAppName, "EnableProxy" ,  0,ini_file);
	m_bSaveStream   = GetPrivateProfileInt(szAppName, "SaveStream" ,  0,ini_file);
	m_bTitleStreaming   = GetPrivateProfileInt(szAppName,"TitleStreaming" ,  1,ini_file);
	m_bTitleStreamingDecode   = GetPrivateProfileInt(szAppName,"DecodeText" ,  1,ini_file);
	m_bTitleStreamingUDP   = GetPrivateProfileInt(szAppName,"UseUDP" ,  1,ini_file);

	GetPrivateProfileString(szAppName, "Format", "%1 - %2", buf,255,ini_file);
	m_strID3Format = buf;
	GetPrivateProfileString(szAppName, "SIFFormat", "%IART - %INAM", buf, 255,ini_file);
	m_strSIFFormat = buf;
	GetPrivateProfileString(szAppName, "Proxy" , "", buf,255,ini_file);
	m_strProxy = buf;
	GetPrivateProfileString(szAppName, "SaveStreamFile", "", buf, 255,ini_file);
	m_strSaveStream = buf;
	GetPrivateProfileString(szAppName, "TitleStreamingFormat" , "%1 (%2)", buf,255,ini_file);
	m_strTitleStreamingFormat = buf;
}

void CIn_mpg123dParam::WriteProfile(void)
{
	char string[32];
	char szAppName[] = "Shibatch mpg123";

	wsprintf(string,"%d",m_bEnable);
	WritePrivateProfileString(szAppName,"Enable",string,ini_file);

	wsprintf(string,"%d",m_bSupZero);
	WritePrivateProfileString(szAppName,"SupZero",string,ini_file);

	wsprintf(string,"%d",m_bForce);
	WritePrivateProfileString(szAppName,"Force",string,ini_file);

	wsprintf(string,"%d",m_bDispAvg);
	WritePrivateProfileString(szAppName,"DispAvg",string,ini_file);

	wsprintf(string,"%d",m_bAltVolume);
	WritePrivateProfileString(szAppName,"Volume",string,ini_file);

	wsprintf(string,"%d",m_bReverse);
	WritePrivateProfileString(szAppName,"Reverse",string,ini_file);

	wsprintf(string,"%d",m_bInvert);
	WritePrivateProfileString(szAppName,"Invert",string,ini_file);

	wsprintf(string,"%d",m_bFullBuffering);
	WritePrivateProfileString(szAppName,"FullBuffering",string,ini_file);

	wsprintf(string,"%d",m_nOutputBps);
	WritePrivateProfileString(szAppName,"OutputFormat",string,ini_file);

	wsprintf(string,"%d",m_nVolume);
	WritePrivateProfileString(szAppName,"XVolume",string,ini_file);

	wsprintf(string,"%d",m_nPan);
	WritePrivateProfileString(szAppName,"XPan",string,ini_file);

	wsprintf(string,"%d",m_nBufferLength);
	WritePrivateProfileString(szAppName,"StrBuf",string,ini_file);

	wsprintf(string,"%d",m_bProxy);
	WritePrivateProfileString(szAppName,"EnableProxy",string,ini_file);

	wsprintf(string,"%d",m_bSaveStream);
	WritePrivateProfileString(szAppName,"SaveStream",string,ini_file);

	wsprintf(string,"%d",m_bTitleStreaming);
	WritePrivateProfileString(szAppName,"TitleStreaming",string,ini_file);

	wsprintf(string,"%d",m_bTitleStreamingDecode);
	WritePrivateProfileString(szAppName,"DecodeText",string,ini_file);

	wsprintf(string,"%d",m_bTitleStreamingUDP);
	WritePrivateProfileString(szAppName,"UseUDP",string,ini_file);

	wsprintf(string,"%d",m_nDecodeThreadPriority);
	WritePrivateProfileString(szAppName,"DecodePriority",string,ini_file);
	wsprintf(string,"%d",m_nReceiveThreadPriority);
	WritePrivateProfileString(szAppName,"ReceivePriority",string,ini_file);
	wsprintf(string,"%d",m_nInetReadThreadPriority);
	WritePrivateProfileString(szAppName,"InetReadPriority",string,ini_file);

	WritePrivateProfileString(szAppName,"Format",(LPCTSTR)m_strID3Format,ini_file);
	WritePrivateProfileString(szAppName,"SIFFormat",(LPCTSTR)m_strSIFFormat,ini_file);
	WritePrivateProfileString(szAppName,"Proxy",(LPCTSTR)m_strProxy,ini_file);
	WritePrivateProfileString(szAppName,"SaveStreamFile",(LPCTSTR)m_strSaveStream,ini_file);
	WritePrivateProfileString(szAppName,"TitleStreamingFormat",(LPCTSTR)m_strTitleStreamingFormat,ini_file);
}


/////////////////////////////////////////////////////////////
// URL Decode 
// GXP[vꂽ{ɖ߂
//
char CIn_mpg123dParam::x2c(char *what)
{
    char digit;

    digit = (what[0] >= 'A' ? ((what[0] & 0xdf) - 'A')+10 : (what[0] - '0'));
    digit *= 16;
    digit += (what[1] >= 'A' ? ((what[1] & 0xdf) - 'A')+10 : (what[1] - '0'));

    return(digit);
}

void CIn_mpg123dParam::URLDecode(char* src, char* dst)
{
	unsigned char c;
	char *p;
	BOOL bFlag = FALSE;
	BOOL bRadioSpy = FALSE;

	p = src;

	while (c = (unsigned char)*p++) {
		switch (c) {
		case 0xff:
			if ((*p == 0x66) && (*(p+1) == 0x66) && (*(p+2) == 0x66) && (*(p+3) == 0x66) && (*(p+4)) && (*(p+5)) ) {
				bRadioSpy = TRUE;
				p += 4; /* 66 66 66 66 '8' 'C' */
				c = x2c(p);

				if (((c >= 0x81) && (c <= 0x9F))
					|| ((c >= 0xE0) && (c <= 0xEF))) {
					if(bFlag) {
						bFlag = FALSE;
					} else {
						// SJIS 1oCg
						bFlag = TRUE;
					}
				} else {
					bFlag = FALSE;
				}

				p += 2;
			} else {
				// SJISꕶڂ폜
				if(bFlag) {
					*(dst - 1) = NULL;
				}
				bFlag = FALSE;
				// NULLpfBO
				c = NULL;
			}
			break;
		case '%':
			bFlag = FALSE;
			if ((*p) && (*(p+1))) {
				c = x2c(p);
				p += 2;
			} else {
				c = NULL;
			}
			break;
		default:
			if ((c < 0x40) || (c > 0xfc)) {
				// SJISꕶڂ폜
				if(bFlag) {
					dst--;
				}
			}

			if(bRadioSpy) {
				if ((c < 0x20) || (c >= 0x80)) {
					// ςȕoĂp[Xł
					*dst++ = NULL;
				}
			}

			bFlag = FALSE;
		}
		*dst++ = c;
	}
    *dst = NULL;
}

int CIn_mpg123dParam::GetPriorityValue(int n)
{
	int ret;
	
	switch(n) {
	case 0:
		ret = THREAD_PRIORITY_NORMAL;
		break;
	case 1:
		ret = THREAD_PRIORITY_ABOVE_NORMAL;
		break;
	case 2:
	default:
		ret = THREAD_PRIORITY_HIGHEST;
	}
	return ret;
}
