// SIFInfo.cpp: CSIFInfo NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "in_mpg123d.h"
#include <mmsystem.h>
#include <mmreg.h>
#include "SIFInfo.h"

// added by Otachan
#include "CommonFunc.h"
//

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CSIFInfo::CSIFInfo()
{
	Init();
}

CSIFInfo::~CSIFInfo()
{

}

void CSIFInfo::Init()
{
	// 
	m_file      = "";
	m_title     = "";
	m_artist    = "";
	m_album     = "";
	m_year      = "";
	m_comment   = "";
	m_genre     = "";
	m_engineer  = "";
	m_copyright = "";
	m_source    = "";
	m_software  = "";
	m_datasize  = 0;
	m_filesize  = 0;
	m_enable = FALSE;
}

void CSIFInfo::GetSIFInfoNew(mmioParam* mmio)
{
	mmio->hmmio = NULL;
	mmio->mmckinfoParent       = new MMCKINFO;
	mmio->mmckinfoSubchunk     = new MMCKINFO;
	mmio->mmckinfoSubSubchunk  = new MMCKINFO;
	mmio->pFormat = NULL;
}

void CSIFInfo::GetSIFInfoDelete(mmioParam* mmio)
{
	if(mmio->hmmio) {
		mmioClose(mmio->hmmio, 0);
		mmio->hmmio = NULL;
	}
	delete mmio->mmckinfoParent;
	delete mmio->mmckinfoSubchunk;
	delete mmio->mmckinfoSubSubchunk;
	if(mmio->pFormat) {
		delete mmio->pFormat;
		mmio->pFormat = NULL;
	}

	delete mmio;
	mmio = NULL;
}

void CSIFInfo::GetSIFInfoString(mmioParam* mmio, CString* str)
{
	char *p;
	DWORD dwListSize;

	if (mmioDescend(mmio->hmmio, mmio->mmckinfoSubSubchunk,
		mmio->mmckinfoSubchunk, MMIO_FINDCHUNK) == NULL) {
		
		dwListSize = mmio->mmckinfoSubSubchunk->cksize;
		// t@CTCY傫͖̂炩Ɉُ
		if(dwListSize > m_filesize) {
			dwListSize = m_filesize;
		}
		p = new char[dwListSize + 1];
		if(mmioRead(mmio->hmmio, (HPSTR)p, dwListSize) == (LONG) dwListSize) {
			*(p + dwListSize) = NULL;
			*str = p;
		}
		delete p;
		mmioAscend(mmio->hmmio, mmio->mmckinfoSubSubchunk, 0);
	}
}

int CSIFInfo::GetSIFInfo(char *fn)
{

	// o
	mmioParam* mmio;
	MMRESULT ret;
	DWORD dwDataSize;
	int hpos;
	CString str;

	// new
	mmio = new mmioParam;
	GetSIFInfoNew(mmio);

	// obt@tI/OgēǂݎpƂăt@CJ
	if(!(mmio->hmmio = mmioOpen(fn, NULL, MMIO_READ | MMIO_ALLOCBUF))) {
		GetSIFInfoDelete(mmio);
		return 0;
	}

	// 'RMP3'tH[^Cv'RIFF'`NAꂪ
	// WAVEt@Cł邩ǂmF
	mmio->mmckinfoParent->fccType = mmioFOURCC('R', 'M', 'P', '3');
	if (mmioDescend(mmio->hmmio, mmio->mmckinfoParent, NULL, MMIO_FINDRIFF)) {

		mmioSeek(mmio->hmmio, 0, SEEK_SET);
		// 'WAVE'tH[^Cv'RIFF'`NAꂪ
		// WAVEt@Cł邩ǂmF
		mmio->mmckinfoParent->fccType = mmioFOURCC('W', 'A', 'V', 'E');
		if (mmioDescend(mmio->hmmio, mmio->mmckinfoParent, NULL, MMIO_FINDRIFF)) {
			// RMP3Ȃ
			GetSIFInfoDelete(mmio);
			return 0;
		}
		// ``N(tH[^Cv'fmt')B
		// ́Ae`N'RIFF'̃Tu`NłȂ΂ȂȂ
		mmio->mmckinfoSubchunk->ckid = mmioFOURCC('f', 'm', 't', ' ');
		if (mmioDescend(mmio->hmmio, mmio->mmckinfoSubchunk,
			mmio->mmckinfoParent, MMIO_FINDCHUNK)) {
			GetSIFInfoDelete(mmio);
			return 0;
		}

		// ``ÑTCY̕蓖āAbN
		dwDataSize = mmio->mmckinfoSubchunk->cksize;
		if((mmio->pFormat = (WAVEFORMATEX *)new char [dwDataSize]) == NULL) {
			GetSIFInfoDelete(mmio);
			return 0;
		}

		// ``Nǂݎ
		if (mmioRead(mmio->hmmio, (HPSTR)mmio->pFormat, dwDataSize) != (LONG) dwDataSize) {
			GetSIFInfoDelete(mmio);
			return 0;
		}
    
		// 85Ԃł邱ƂmF
		if (mmio->pFormat->wFormatTag != 85) {
			// ȊOȂ烁
			GetSIFInfoDelete(mmio);
			return 0;
		}

		// `Tu`Nړ
		mmioAscend(mmio->hmmio, mmio->mmckinfoSubchunk, 0);
	
	}

	// f[^Tu`N
	mmio->mmckinfoSubchunk->ckid = mmioFOURCC('d', 'a', 't', 'a');
	if (mmioDescend(mmio->hmmio, mmio->mmckinfoSubchunk,
		mmio->mmckinfoParent, MMIO_FINDCHUNK)) {
		GetSIFInfoDelete(mmio);
		return 0;
	}

	// f[^Tu`ÑTCY擾
	dwDataSize = mmio->mmckinfoSubchunk->cksize;
	if (dwDataSize == 0L) {
		GetSIFInfoDelete(mmio);
		return 0;
	}
	// hposZbg
	hpos = mmio->mmckinfoSubchunk->dwDataOffset;
	// dataTCY
	m_datasize = dwDataSize;

	// dataTu`Nړ
	mmioAscend(mmio->hmmio, mmio->mmckinfoSubchunk, 0);

	// LISTTu`N
	mmio->mmckinfoSubchunk->ckid = mmioFOURCC('L', 'I', 'S', 'T');

	if ((ret = mmioDescend(mmio->hmmio, mmio->mmckinfoSubchunk,
		mmio->mmckinfoParent, MMIO_FINDCHUNK)) == NULL) {
		//  LIST`NȂ

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'N', 'A', 'M');
		GetSIFInfoString(mmio, &m_title);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'A', 'R', 'T');
		GetSIFInfoString(mmio, &m_artist);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'P', 'R', 'D');
		GetSIFInfoString(mmio, &m_album);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'C', 'R', 'D');
		GetSIFInfoString(mmio, &m_year);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'C', 'M', 'T');
		GetSIFInfoString(mmio, &m_comment);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'C', 'O', 'P');
		GetSIFInfoString(mmio, &m_copyright);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'S', 'R', 'C');
		GetSIFInfoString(mmio, &m_source);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'G', 'N', 'R');
		GetSIFInfoString(mmio, &m_genre);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'E', 'N', 'G');
		GetSIFInfoString(mmio, &m_engineer);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		mmio->mmckinfoSubSubchunk->ckid = mmioFOURCC('I', 'S', 'F', 'T');
		GetSIFInfoString(mmio, &m_software);
		mmioSeek(mmio->hmmio, mmio->mmckinfoSubchunk->dwDataOffset + 4, SEEK_SET);

		m_file = fn;
		m_enable = TRUE;
		mmioAscend(mmio->hmmio, mmio->mmckinfoSubchunk, 0);
	}
	// delete
	GetSIFInfoDelete(mmio);

	return hpos;
}

#define TITLEBUFLEN (MAX_PATH-10)

int CSIFInfo::GetTitleFromSIF(char *filename, char *title, const char* format)
{
	const char *p;
	char *q/*,*r,*s*/;
	int remain = TITLEBUFLEN;
	int		StrLen;

	q = title;

	for(p=format;*p != '\0' && remain > 0;)
	{
		if (*p != '%') {
			*q++ = *p++;
			remain--;
			continue;
		}

		switch(*++p)
		{
		case '%':
			*q++ = '%';
			remain--;
			break;
		case '1':
			strncpy(q, (LPCTSTR)m_artist, remain);
			remain -= m_artist.GetLength();
			q += m_artist.GetLength();
			break;
		case '2':
			strncpy(q, (LPCTSTR)m_title, remain);
			remain -= m_title.GetLength();
			q += m_title.GetLength();
			break;
		case '3':
			strncpy(q, (LPCTSTR)m_album, remain);
			remain -= m_album.GetLength();
			q += m_album.GetLength();
			break;
		case '4':
			strncpy(q, (LPCTSTR)m_year, remain);
			remain -= m_year.GetLength();
			q += m_year.GetLength();
			break;
		case '5':
			strncpy(q, (LPCTSTR)m_comment, remain);
			remain -= m_comment.GetLength();
			q += m_comment.GetLength();
			break;
		case '6':
			strncpy(q, (LPCTSTR)m_genre, remain);
			remain -= m_genre.GetLength();
			q += m_genre.GetLength();
			break;
		case '7':
			{
				char	Name[MAX_PATH];
				char	NameOnly[MAX_PATH];

				CutPathFileName(filename, NULL, Name);
				CutFileNameExt(Name, NameOnly, NULL);
				Strncpy(q, NameOnly, remain);
				StrLen = strlen(NameOnly);
				remain -= StrLen;
				q += StrLen;
			}
/*
			r=s=filename+strlen(filename);
			while (*r != '\\' && r >= filename) r--;
			r++;
			while (*s != '.'  && s >= filename) s--;
			if (s < r) s = filename+strlen(filename);
			while(r < s && remain > 0) {
				*q++ = *r++;
				remain--;
			}
*/
			break;
		case '8':
			{
				char	Path[MAX_PATH];

				CutPathFileName(filename, Path, NULL);
				Strncpy(q, Path, remain);
				StrLen = strlen(Path);
				remain -= StrLen;
				q += StrLen;
			}
/*
			s=filename+strlen(filename);
			while (*s != '\\' && s >= filename) s--;
			if (*s == '\\') s++;
			r = filename;
			while(r < s && remain > 0) {
				*q++ = *r++;
				remain--;
			}
*/
			break;
		case '9':
			{
				char	Ext[MAX_PATH];

				CutFileNameExt(filename, NULL, Ext);
				Strncpy(q, Ext, remain);
				StrLen = strlen(Ext);
				remain -= StrLen;
				q += StrLen;
			}
/*
			r=s=filename+strlen(filename);
			while (*r != '\\' && r >= filename) r--;
			while (*s != '.'  && s >= filename) s--;
			if (s < r) s = filename+strlen(filename);
			while(*s != '\0' && remain > 0) {
				*q++ = *s++;
				remain--;
			}
*/
			break;
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
			break;
		default:
			if (remain >= 1) { *q++ = '%'; remain--; }
			if (remain >= 1) { *q++ = *p;  remain--; }
			break;
		}

		p++;
	}

	*q = '\0';

	return 1;
}
