
/*
** in_mpg123 - a MP3 decoder plugin based on mpg123
** Written by Naoki Shibata
** http://shibatch.sourceforge.net/
**
** 2003/04/06 Modified by Otachan
** http://www.aikis.or.jp/~otachan/
*/

#include "stdafx.h"
#include "process.h"
#include "in_mpg123d.h"
// begin pl2 by YunaSoft
#include "in_mpg123dAsyncSocket.h"
#include "in_mpg123dHttpFile.h"
// end pl2

// begin pl3 by YunaSoft
#include "in_mpg123dParam.h"
#include "ConfigDialog.h"
#include "FormattingDialog.h"
#include "StreamingDialog.h"
#include "in_mpg123dPropertySheet.h"
// end pl3

// added by Otachan
#include "CommonFunc.h"
#include "FileSys.h"
#include "ID3v2Info.h"
#include "mp3infp_ExportFunc.h"
//

#define	IN_MPG123D_FILESYS_NO	0

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define VERSIONSTRINGBASE "v1.18y ot40a"

#ifdef __ICL
#define VERSIONSTRING VERSIONSTRINGBASE"+"
#else
#define VERSIONSTRING VERSIONSTRINGBASE
#endif

BEGIN_MESSAGE_MAP(CIn_mpg123dApp, CWinApp)
	//{{AFX_MSG_MAP(CIn_mpg123dApp)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CIn_mpg123dApp::CIn_mpg123dApp()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̒̏dvȏׂċLqĂB
}

CIn_mpg123dApp theApp;

#if 1

// begin pl3 by YunaSoft
//#include <windows.h>
//#include <mmsystem.h>
//#include <mmreg.h>
// end pl3
// begin pl2 by YunaSoft
//#include <afxinet.h>
// end pl2

// begin pl3 by YunaSoft
//#include "ConfigDialog.h"
// end pl3

// avoid CRT. Evil. Big. Bloated.
/*
BOOL WINAPI _DllMainCRTStartup(HANDLE hInst, ULONG ul_reason_for_call, LPVOID lpReserved)
{
	return TRUE;
}
*/

#include <math.h>
#include <string.h>

extern "C" {
#include "mpglib/mpg123.h"
#include "mpglib/mpglib.h"
#include "in2.h"
#include "VbrTag.h"
}
#define	MAX_PATHLEN			512

#define	WM_WA_MPEG_EOF		WM_USER+2
#define	WM_WA_MPG123_IPC	WM_USER+499

#define	FILE_EXT			"MP3\0MP3 Audio File (*.MP3)\0"\
							"RMP\0RIFF MP3 Audio File (*.RMP)\0"

#include "AdrTime.h"

CAdrTime g_adrTime;

void config(HWND);
void about(HWND);
void init();
void quit();
void getfileinfo(char*, char*, int*);
int infoDlg(char*, HWND);
int isourfile(char*);
int play(char*);
void pause();
void unpause();
int ispaused();
void stop();
int getlength();
int getoutputtime();
void setoutputtime(int);
void setvolume(int);
void setpan(int);
void eq_set(int, char data[10], int) ;

In_Module mod = 
{
	IN_VER,
	"Shibatch mpg123 plug-in " VERSIONSTRING,
	0,	// hMainWindow
	0,  // hDllInstance
	FILE_EXT,
	1,	// is_seekable
	1,  // uses output
	config,
	about,
	init,
	quit,
	getfileinfo,
	infoDlg,
	isourfile,
	play,
	pause,
	unpause,
	ispaused,
	stop,
	
	getlength,
	getoutputtime,
	setoutputtime,

	setvolume,
	setpan,

	0,0,0,0,0,0,0,0,0,
	0,0,

	eq_set,

	NULL,

	0
};

extern "C" {
__declspec( dllexport ) In_Module * winampGetInModule2()
{
	return &mod;
}
}

// begin pl2 by YunaSoft
BOOL ConnectAsyncSocket(CString strAddress, UINT nPort);
UINT CreateAsyncSocket(UINT nPort, UINT count);
void ReceiveUDPMsg(char *src);
BOOL CheckThread(HANDLE hThread);
UINT ReceiveThread(LPVOID pParam);
//UINT DecodeThread(LPVOID pParam);
unsigned int __stdcall DecodeThread(LPVOID pParam);
// end pl2
// begin pl3 by YunaSoft
void DeleteAsyncSocket();
void UpdateWinampDisplay();
UINT ReadStream(char* buf, UINT nCount);
void reflect_setting(void);
// end pl3

char lastfn[MAX_PATH]; // currently playing file (used for getting info on the current file)
int file_length;       // file length, in bytes
double decode_pos_ms;     // current decoding position, in milliseconds
int paused;            // are we paused?
int seek_needed;       // if != -1, it is the point that the decode thread should seek to, in ms.
int m_Format;
int m_OutputBps;
int m_ssize;
char sample_buffer[576 * 2 * 8 * 2]; // sample buffer
char sample_16_buffer[576 * 2 * 2]; // sample buffer(16bit)
volatile int decoder_in_use = 0;
HMODULE hMp3infpDll = NULL;
LPMP3INFP_VIEWPROP lpfnMp3infpViewProp;
// begin pl3 by YunaSoft
//int xvolume,xpan;
// end pl3

// begin pl3 by YunaSoft
//CInternetSession *session=NULL;
CIn_mpg123dSession *session=NULL;
CIn_mpg123dHttpFile *httpfile=NULL;
CIn_mpg123dAsyncSocket* m_pAsyncSocket=NULL;
THREADPARAM* pReceive = NULL;
THREADPARAM* pDecode = NULL;
CIn_mpg123dParam* prm;
CMemFile memf;
BYTE *pBuf = NULL;

// end pl3

char *stream_buffer=NULL;
volatile int strbufp_s=0,strbufp_e=0,strbuf_eof=0;
int strbuflen;

//HANDLE input_file=INVALID_HANDLE_VALUE; // input file handle
FileSys*	input_file = NULL;

// begin pl3 by YunaSoft
/*
int killDecodeThread=0;					// the kill switch for the decode thread
HANDLE decode_thandle=INVALID_HANDLE_VALUE;	// the handle to the decode thread

int killReceiveThread=0;					// the kill switch for the decode thread
HANDLE receive_thandle=INVALID_HANDLE_VALUE;	// the handle to the decode thread
*/
// end pl3

// begin pl2 by YunaSoft
//DWORD WINAPI __stdcall DecodeThread(void *b);  // the decode thread procedure
//DWORD WINAPI __stdcall ReceiveThread(void *b); // the receive thread procedure// end pl2

// Variable to estimate bitrate

// extern "C" int totalFramesize,nframe,currentBitrate;

// Variables which keep state of config panel

// begin pl3 by YunaSoft
/*
extern char xed_title[256];
extern int xch_enable;
extern int xch_supzero;
extern int xch_force;
extern int xch_dispavg;
extern int xch_24bit;
extern int xch_volume;
extern int xch_reverse;
extern int xch_invert;
extern int xstrbuflen;
extern char xed_proxy[256];
*/
// end pl3

// Code to extract info from MP3 file.

static int tabsel_123[2][3][16] = {
   { {0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,},
     {0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384,},
     {0,32,40,48, 56, 64, 80, 96,112,128,160,192,224,256,320,} },

   { {0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,},
     {0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,},
     {0,8,16,24,32,40,48,56,64,80,96,112,128,144,160,} }
};

typedef struct id3tag {
	char tag[3];
	char title[30];
	char artist[30];
	char album[30];
	char year[4];
	char comment[30];
	unsigned char genre;
} id3tag;

// begin pl3 by YunaSoft
/*
typedef struct mmioParam {
    HMMIO           hmmio;
	MMCKINFO*       mmckinfoParent;
	MMCKINFO*       mmckinfoSubchunk;
	MMCKINFO*       mmckinfoSubSubchunk;
	WAVEFORMATEX	*pFormat;
} mmioParam;

CSIFData sif;
*/
// end pl3

id3tag current_id3;

static char	VBRTag[]={"Xing"};

VBRTAGDATA current_vbrtag;

typedef struct mp3info {
	int nbytes,freq,nch,hpos;
	int hasVbrtag,lsf,bitrate,isStream;
	double length;
} mp3info;

mp3info cur_mp3info;


static int ExtractI4(unsigned char *buf)
{
	int x;
	x = buf[0];
	x <<= 8;
	x |= buf[1];
	x <<= 8;
	x |= buf[2];
	x <<= 8;
	x |= buf[3];
	return x;
}

int GetVbrTag(VBRTAGDATA *pTagData,  unsigned char *buf)
{
	int			i, head_flags;
	int			h_id, h_mode, h_sr_index;
	static int	sr_table[4] = { 44100, 48000, 32000, 99999 };

	pTagData->flags = 0;     

	h_id       = (buf[1] >> 3) & 1;
	h_sr_index = (buf[2] >> 2) & 3;
	h_mode     = (buf[3] >> 6) & 3;

	if( h_id ) 
	{
		if( h_mode != 3 )	buf+=(32+4);
		else				buf+=(17+4);
	}
	else
	{
		if( h_mode != 3 ) buf+=(17+4);
		else              buf+=(9+4);
	}
	
	if( buf[0] != VBRTag[0] ) return 0;
	if( buf[1] != VBRTag[1] ) return 0;
	if( buf[2] != VBRTag[2] ) return 0;
	if( buf[3] != VBRTag[3] ) return 0;

	buf+=4;

	pTagData->h_id = h_id;

	pTagData->samprate = sr_table[h_sr_index];

	if( h_id == 0 )
		pTagData->samprate >>= 1;

	head_flags = pTagData->flags = ExtractI4(buf); buf+=4;

	if( head_flags & FRAMES_FLAG )
	{
		pTagData->frames   = ExtractI4(buf); buf+=4;
	}

	if( head_flags & BYTES_FLAG )
	{
		pTagData->bytes = ExtractI4(buf); buf+=4;
	}

	if( head_flags & TOC_FLAG )
	{
		if( pTagData->toc != NULL )
		{
			for(i=0;i<NUMTOCENTRIES;i++)
				pTagData->toc[i] = buf[i];
		}
		buf+=NUMTOCENTRIES;
	}

	pTagData->vbr_scale = -1;

	if( head_flags & VBR_SCALE_FLAG )
	{
		pTagData->vbr_scale = ExtractI4(buf); buf+=4;
	}

	return 1;
}

static int head_check(unsigned long head)
{
    if ((head & 0xffe00000) != 0xffe00000) return FALSE;
    if (!((head>>17)&3)) return FALSE;
    if (((head>>12)&0xf) == 0xf) return FALSE;
    if (((head>>10)&0x3) == 0x3 ) return FALSE;
    //if ((head & 0xffff0000) == 0xfffe0000) return FALSE;
	if ((4-((head>>17)&3)) != 3) return FALSE;
    return TRUE;
}

static int head_check2(unsigned long head,mp3info *info)
{
	int lsf,srate,nch,lay,mpeg25,freq,mode;

    if ((head & 0xffe00000) != 0xffe00000) return FALSE;
    if (!((head>>17)&3)) return FALSE;
    if (((head>>12)&0xf) == 0xf) return FALSE;
    if (((head>>10)&0x3) == 0x3 ) return FALSE;
    //if ((head & 0xffff0000) == 0xfffe0000) return FALSE;

    if( head & (1<<20) ) {
      lsf = (head & (1<<19)) ? 0x0 : 0x1;
      mpeg25 = 0;
    } else {
      lsf = 1;
      mpeg25 = 1;
    }

	if(mpeg25) srate = 6 + ((head>>10)&0x3);
    else srate = ((head>>10)&0x3) + (lsf*3);

    mode  = ((head>>6)&0x3);
	freq  = freqs[srate];
    nch   = (mode == MPG_MD_MONO) ? 1 : 2;
	lay   = 4-((head>>17)&3);

	if (lay != 3) return FALSE;
	if (nch != info->nch) return FALSE;
	if (freq != info->freq) return FALSE;

    return TRUE;
}


// for streaming
int getmp3info2(mp3info *info)
{
	int i;
	int head;
	int lsf,srate;
	int bitrate_index,mode,nch,lay,extension,mpeg25,padding;

	// sif
	prm->m_sif.Init();

	for(i=0;i<strbuflen-4;i++)
	{
		while(!strbuf_eof && strbufp_e-4 < i) Sleep(100);

		*(3+(char *)&head) = stream_buffer[i  ];
		*(2+(char *)&head) = stream_buffer[i+1];
		*(1+(char *)&head) = stream_buffer[i+2];
		*(0+(char *)&head) = stream_buffer[i+3];

		if (strbuf_eof || head_check(head)) break;
	}

	{
		char mes[64];
		wsprintf(mes,"strbuf_eof=%d,i=%d",strbuf_eof,i);
		//MessageBox(mod.hMainWindow,mes,"getmp3info2",0);
	}

	if (strbuf_eof || i == strbuflen-4) return 0;

	strbufp_s = i;

    if( head & (1<<20) ) {
      lsf = (head & (1<<19)) ? 0x0 : 0x1;
      mpeg25 = 0;
    } else {
      lsf = 1;
      mpeg25 = 1;
    }

    bitrate_index = ((head>>12)&0xf);
	padding       = ((head>>9)&0x1);
    mode          = ((head>>6)&0x3);
    nch           = (mode == MPG_MD_MONO) ? 1 : 2;
	lay           = 4-((head>>17)&3);
	extension     = ((head>>8)&0x1);

	if(mpeg25) srate = 6 + ((head>>10)&0x3);
    else srate = ((head>>10)&0x3) + (lsf*3);

	if (lay != 3) return 0;

	info->isStream = 1;
	info->nbytes = 0;
	info->hpos = 0;
	info->length = 0;
	info->lsf  = lsf;
	info->freq = freqs[srate];
	info->nch  = nch;
	info->hasVbrtag = 0;
	info->bitrate = tabsel_123[lsf][lay-1][bitrate_index]*1000;
	
	return 1;
}

int getmp3info(char *fn,mp3info *info,id3tag *id3,VBRTAGDATA *vbr)
{
	DWORD len;
	unsigned int head;
	int lsf,srate;
	int bitrate_index,mode,nch,lay,extension,mpeg25,padding;
	int hpos,i;
	HANDLE input_file;

	input_file = CreateFile(fn,GENERIC_READ,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL | FILE_FLAG_RANDOM_ACCESS,NULL);

	if (input_file == INVALID_HANDLE_VALUE) // error opening file
	{
		return 0;
	}

	info->isStream = 0;
	info->nbytes = GetFileSize(input_file, NULL);

	hpos = 0;

	// begin pl3 by YunaSoft
	prm->m_sif.Init();
	// end pl3

	// skip ID3v2 tag
	{
		unsigned char c1,c2,c3,c4;

		ReadFile(input_file,&c1,1,&len,NULL);
		ReadFile(input_file,&c2,1,&len,NULL);
		ReadFile(input_file,&c3,1,&len,NULL);
		ReadFile(input_file,&c4,1,&len,NULL);

		if (c1 == 'I' && c2 == 'D' && c3 == '3'/* && c4 == 2*/) {
			SetFilePointer(input_file,6,NULL,FILE_BEGIN);
			ReadFile(input_file,&c1,1,&len,NULL);
			ReadFile(input_file,&c2,1,&len,NULL);
			ReadFile(input_file,&c3,1,&len,NULL);
			ReadFile(input_file,&c4,1,&len,NULL);
			hpos = c1*2097152+c2*16384+c3*128+c4;
		} else // skip RIFF chunk
		if (c1 == 'R' && c2 == 'I' && c3 == 'F' && c4 == 'F') {
			// begin pl3 by YunaSoft
			prm->m_sif.m_filesize = info->nbytes;
			hpos = prm->m_sif.GetSIFInfo(fn);
			// end pl3
		}
	}

	bool	FindHeader = false;

	for(i = 0; i < 65536; i++) {
		SetFilePointer(input_file, hpos + i, NULL, FILE_BEGIN);
		ReadFile(input_file, &head, 4, &len, NULL);

		if(len < 4) break;

		if(head_check(head = BSwap(head))) {
			FindHeader = true;
			break;
		}
	}

	if(FindHeader == false) {
		CloseHandle(input_file);
		return 0;
	}

	hpos += i;
	info->hpos = hpos;

	// begin pl1 by YunaSoft
	// read ID3 tag
	SetFilePointer(input_file,-128,NULL,FILE_END);
	ReadFile(input_file,id3,128,&len,NULL);

	// begin pl3 by YunaSoft
	if(prm->m_sif.m_datasize) {
		info->nbytes = prm->m_sif.m_datasize;
	} else {
		info->nbytes -= hpos;
		if (strncmp(id3->tag,"TAG",3) == 0) info->nbytes -= 128;
	}
	// end pl3
	// end pl1

	SetFilePointer(input_file,hpos,NULL,FILE_BEGIN);

    if( head & (1<<20) ) {
      lsf = (head & (1<<19)) ? 0x0 : 0x1;
      mpeg25 = 0;
    } else {
      lsf = 1;
      mpeg25 = 1;
    }

    bitrate_index = ((head>>12)&0xf);
	padding       = ((head>>9)&0x1);
    mode          = ((head>>6)&0x3);
    nch           = (mode == MPG_MD_MONO) ? 1 : 2;
	lay           = 4-((head>>17)&3);
	extension     = ((head>>8)&0x1);

	if(mpeg25) srate = 6 + ((head>>10)&0x3);
    else srate = ((head>>10)&0x3) + (lsf*3);

	if (lay != 3)
	{
		CloseHandle(input_file);
		return 0;
	}

	// read VBR tag

	SetFilePointer(input_file,hpos,NULL,FILE_BEGIN);

	info->lsf  = lsf;
	info->freq = freqs[srate];
	info->nch  = nch;
	
	{
		unsigned char buf[VBRHEADERSIZE+36];

		ReadFile(input_file,buf,VBRHEADERSIZE+36,&len,NULL);
		if (GetVbrTag(&current_vbrtag,buf)) {
			int cur_bitrate = (int)(current_vbrtag.bytes*8/(current_vbrtag.frames*576.0*(lsf?1:2)/freqs[srate]));
			info->length = current_vbrtag.frames*576.0*(lsf?1:2)/freqs[srate];
			info->nbytes = current_vbrtag.bytes;
			info->hasVbrtag = 1;
			info->bitrate = cur_bitrate;
		} else {
			int framesize = tabsel_123[lsf][lay-1][bitrate_index]*144000/(freqs[srate]<<lsf)+padding;
			info->length = info->nbytes/framesize*576.0*(lsf?1:2)/freqs[srate];
			info->hasVbrtag = 0;
			info->bitrate = tabsel_123[lsf][lay-1][bitrate_index]*1000;
			//info->length = info->nbytes * 8 / info->bitrate;
		}
	}

	CloseHandle(input_file);

	return 1; 
}

int SeekPoint(unsigned char TOC[NUMTOCENTRIES], int file_bytes, double percent)
{
	/* interpolate in TOC to get file seek point in bytes */
	int a, seekpoint;
	double fa, fb, fx;

	if( percent < (double)0.0 )   percent = (double)0.0;
	if( percent > (double)100.0 ) percent = (double)100.0;

	a = (int)percent;
	if( a > 99 ) a = 99;
	fa = TOC[a];
	if( a < 99 ) {
		fb = TOC[a+1];
	} else {
		fb = (double)256.0;
	}

	fx = fa + (fb-fa)*(percent-a);

	seekpoint = (int)(((double)(1.0/256.0))*fx*file_bytes); 

	return seekpoint;
}


// begin pl3 by YunaSoft
void reflect_thread_setting()
{
	// Xbh
	if(pReceive) {
		pReceive->mt->SetThreadPriority(
						prm->GetPriorityValue(prm->m_nReceiveThreadPriority));
	}
	if(pDecode) {
//		pDecode->mt->SetThreadPriority(
//						prm->GetPriorityValue(prm->m_nDecodeThreadPriority));

		::SetThreadPriority(pDecode->Thread,
						prm->GetPriorityValue(prm->m_nDecodeThreadPriority));
	}
	/*
	if(httpfile) {
		SetThreadPriority(httpfile->pParam->hThread,
			prm->GetPriorityValue(prm->m_nDecodeThreadPriority));
	}
	*/

}
// end pl3

void reflect_setting(void)
{
	// begin pl3 by YunaSoft
	if(prm->m_bEnable) {
		mod.FileExtensions = FILE_EXT;
	} else {
		mod.FileExtensions = "\0\0";
	}

	if(prm->m_bDispAvg && decoder_in_use) {
		mod.SetInfo(cur_mp3info.bitrate/1000,-1,-1,-1);
	}

	forceDecoding = prm->m_bForce;
	// end pl3
}

// begin pl3 by YunaSoft
/*
void config_getinifn(In_Module *this_mod, char *ini_file)
{	// makes a .ini file in the winamp directory named "plugin.ini"
	char *p;
	GetModuleFileName(this_mod->hDllInstance,ini_file,MAX_PATH);
	p=ini_file+strlen(ini_file);
	while (p >= ini_file && *p != '\\') p--;
	if (++p >= ini_file) *p = 0;
	strcat(ini_file,"plugin.ini");
}
*/
// end pl3

void init()
{
	// begin pl3 by YunaSoft
	// makes Parameter Class
	prm = new CIn_mpg123dParam();
	// get profiles
	prm->GetIniFn(mod.hDllInstance);
	prm->GetProfile();
	reflect_setting();
	// end pl3

//	HINSTANCE hDllInstance;
//	In_Module* (*_winampGetInModule2)(void);
}

void quit()
{
	// begin pl3 by YunaSoft
	delete prm;
	if(pBuf != NULL) {
		memf.Detach();
		delete pBuf;
	}
	// end pl3

	if(hMp3infpDll) ::FreeLibrary(hMp3infpDll);
}

//

void config(HWND hwndParent)
{
	// begin pl3 by YunaSoft
	CString str;
	str.LoadString(IDS_CONFIGDLG);

	CIn_mpg123dPropertySheet *prop = new CIn_mpg123dPropertySheet(str, NULL, 0);
//	prop->m_psh.dwFlags |= PSH_USEHICON;
//	prop->m_psh.hIcon = AfxGetApp()->LoadIcon(IDI_SMALLICON);
	prop->m_psh.nStartPage = prm->m_nStartPage;

	prop->pParam = prm;

	CConfigDialog dlg1;
	dlg1.pr = prm;
	dlg1.SetParam();

	CFormattingDialog dlg3;
	dlg3.pr = prm;
	dlg3.SetParam();

	CStreamingDialog dlg4;
	dlg4.pr = prm;
	dlg4.SetParam();

	prop->AddPage(&dlg1);
	prop->AddPage(&dlg3);
	prop->AddPage(&dlg4);

	prop->DoModal();

	delete prop;
	// end pl3

}

void about(HWND hwndParent)
{
	MessageBox(hwndParent,
				"mpg123 plug-in "
				VERSIONSTRING
				" for winamp by Shibatch, YunaSoft, moka, and Otachan\n\n"
				"http://sourceforge.net/projects/shibatch/\n"
				"http://yunasoft.nerv.org/\n"
				"http://www.aikis.or.jp/~otachan/",
				"About", MB_OK);
}

int isourfile(char* fn)
{
	int		RetCode = 0;

	// begin pl3 by YunaSoft
	if(prm->m_bEnable && (strncmp(fn, "http://", 7) == 0)) {
		char	FileExt[MAX_PATHLEN];

		CutFileNameExt(fn, NULL, FileExt);
		if(stricmp(FileExt, "ogg") && stricmp(FileExt, "nsv")) RetCode = 1;
	}
	// end pl3

	return RetCode;
}

void pause()
{
	paused=1;
	mod.outMod->Pause(1);
}

void unpause()
{
	paused=0;
	mod.outMod->Pause(0);
}

int ispaused()
{
	return paused;
}

int getoutputtime()
{
	return (int)(decode_pos_ms+(mod.outMod->GetOutputTime()-mod.outMod->GetWrittenTime())); 
}

void setoutputtime(int time_in_ms)
{
	seek_needed=time_in_ms;
}

void setvolume(int volume)
{
	// begin pl3 by YunaSoft
	prm->m_nVolume = volume;
	// end pl3
	mod.outMod->SetVolume(volume);
}

void setpan(int pan)
{
	// begin pl3 by YunaSoft
	prm->m_nPan = pan;
	// end pl3
	mod.outMod->SetPan(pan);
}

int infoDlg(char *fn, HWND hwnd)
{
	bool	UseMp3infp;

	if(hMp3infpDll) {
		UseMp3infp = true;
	} else {
		hMp3infpDll = ::LoadLibrary("mp3infp.dll");

		if(hMp3infpDll) {
			lpfnMp3infpViewProp = reinterpret_cast<LPMP3INFP_VIEWPROP>
						(::GetProcAddress(hMp3infpDll, "mp3infp_ViewProp"));

			if(lpfnMp3infpViewProp) {
				UseMp3infp = true;
			} else {
				::FreeLibrary(hMp3infpDll);
				hMp3infpDll = NULL;
				UseMp3infp = false;
			}
		} else {
			UseMp3infp = false;
		}
	}

	if(UseMp3infp) {
		lpfnMp3infpViewProp(hwnd, fn, 0);
	} else {
		SHELLEXECUTEINFO	ExecInfo;

		ExecInfo.cbSize = sizeof ExecInfo;
		ExecInfo.fMask = SEE_MASK_INVOKEIDLIST;
		ExecInfo.hwnd = hwnd;
		ExecInfo.lpVerb = "properties";
		ExecInfo.lpFile = fn;
		ExecInfo.lpParameters = "";
		ExecInfo.lpDirectory = NULL;
		ExecInfo.nShow = SW_SHOWNORMAL;
		ExecInfo.hInstApp = NULL;
		ExecInfo.lpIDList = NULL;

		::ShellExecuteEx(&ExecInfo);
	}

	return 0;
}

int getlength()
{ 
	return (int)(cur_mp3info.length * 1000);
}

void eq_set(int on, char data[10], int preamp)
{
}

int play(char *fn)
{
	int m_nOutputBps = prm->m_nOutputBps;

	m_Format = (m_nOutputBps >= 0) ? DATA_FORMAT_LINEAR_PCM : DATA_FORMAT_IEEE_FLOAT;
	m_OutputBps = (m_nOutputBps >= 0) ? m_nOutputBps : -m_nOutputBps;

	int maxlatency;
	int use_proxy = 0;
	static LPCTSTR proxy_bypass = "";
	static LPCTSTR Lversion = "Shibatch in_mpg123 " VERSIONSTRING;
	// begin pl4 by YunaSoft
	int nLoop = 0;
	// end pl4

	while(decoder_in_use) Sleep(30);

	if(strncmp(fn,"http://", 7) == 0) {
		// begin pl3 by YunaSoft
		use_proxy = prm->m_bProxy;
		// end pl3
		mod.is_seekable = 0;

		try {

			// begin pl2 by YunaSoft
			CString strServerName;
			CString strObject;
			INTERNET_PORT nPort;
			DWORD dwServiceType;
			char szHeaders[1024];

			// initialize
			// begin pl3 by YunaSoft
			prm->m_icy.Init();

			session = new CIn_mpg123dSession(
				Lversion,1,
				use_proxy ? INTERNET_OPEN_TYPE_PROXY : INTERNET_OPEN_TYPE_DIRECT,
				prm->m_strProxy,proxy_bypass,INTERNET_FLAG_DONT_CACHE);
			// end pl3

			// begin pl4 by YunaSoft
			session->SetOption(INTERNET_OPTION_CONNECT_TIMEOUT, 5000);
			// end pl4

			// begin pl2 by YunaSoft
			if (!AfxParseURL(fn, dwServiceType, strServerName, strObject, nPort) ||
				dwServiceType != INTERNET_SERVICE_HTTP) {
				return 1;
			}
			// end pl2

			// begin pl3 by YunaSoft
			prm->m_icy.m_server = strServerName;

			// making http header...
			strcpy(szHeaders, "Accept: audio/mpeg, audio/x-mpegurl, */*\r\n");

			if(prm->m_bTitleStreaming) {
				strcat(szHeaders, "icy-metadata: 1\r\n");
			}

			if ((prm->m_bTitleStreamingUDP)
				&&(prm->m_icy.m_udpport = CreateAsyncSocket(nPort, 10))) {
				char tmp[80];
				wsprintf(tmp, "x-audiocast-udpport: %d\r\n", prm->m_icy.m_udpport);
				strcat(szHeaders, tmp);
			}
			strcat(szHeaders, "\r\n");

			if(prm->m_icy.m_udpport > 0) {
				// UDP|[gJ
				ConnectAsyncSocket(prm->m_icy.m_server, prm->m_icy.m_udpport);
			}
			// end pl3

			// begin pl2 by YunaSoft
			httpfile = (CIn_mpg123dHttpFile*)session->OpenURL(fn, 1,
				INTERNET_FLAG_TRANSFER_BINARY|INTERNET_FLAG_RELOAD | INTERNET_FLAG_DONT_CACHE,
				szHeaders, -1);
			// end pl2


		} catch(CInternetException* /*pEx*/) {
			httpfile = NULL;
		}

		if (httpfile == NULL) {
			MessageBox(mod.hMainWindow, "Connection failed",
				"streaming error",0);
			// begin pl2 by YunaSoft
			session->Close();
			delete session;
			session = NULL;
			// end pl2
			// begin pl3 by YunaSoft
			DeleteAsyncSocket();
			// end pl3
			return 1;
		}

		// begin pl3 by YunaSoft
//		httpfile->Init(prm->GetPriorityValue(prm->m_nInetReadThreadPriority));
		httpfile->Init(prm->GetPriorityValue(prm->m_nReceiveThreadPriority));

		stream_buffer = (char *)realloc(stream_buffer,prm->m_nBufferLength*1024);
		strbuflen = prm->m_nBufferLength*1024;
		strbufp_e = strbufp_s = 0;

		// [JXbh쐬Jn
		pReceive = new THREADPARAM;
		pReceive->kill = FALSE;
		pReceive->param = prm;
		pReceive->mt = AfxBeginThread(ReceiveThread, pReceive,
								prm->GetPriorityValue(prm->m_nReceiveThreadPriority));
		pReceive->mt->m_bAutoDelete = FALSE;
		// Xbh
//		pReceive->mt->SetThreadPriority(prm->GetPriorityValue(prm->m_nReceiveThreadPriority));
		// end pl3

		current_id3.tag[0] = '\0';
		
		// ŏ̎M҂2000ms҂
		// begin pl4 by YunaSoft
		while((nLoop < prm->m_nTimeOut) && (!httpfile->pParam->success)) {
			Sleep(200);
			nLoop++;
		}
		// end pl4

		if (!getmp3info2(&cur_mp3info) ||
			(maxlatency = mod.outMod->Open(cur_mp3info.freq, cur_mp3info.nch, m_nOutputBps, -1, -1)) < 0)
		{
			MessageBox(mod.hMainWindow,"Valid MP3 frame not found","streaming error",0);

			// begin pl3 by YunaSoft / ot13 by Otachan
			pReceive->kill = TRUE;
			// MXbh̏I莞ԑ҂
			if(::WaitForSingleObject(pReceive->mt->m_hThread, 5000) != WAIT_OBJECT_0) {
				// Ō̎i
				// 莞ԑ҂ĂIȂƂ́AInternetReadFile API
				// ubNĂƔfAYAPI񂵂ĂXbĥ
				// ނ TerminateThread ĎMXbh̏I҂
				::MessageBox(mod.hMainWindow, "error asking receive thread to die!", "error killing receive thread", MB_OK);
				if(::TerminateThread(httpfile->pParam->hThread, 0)) {
					::WaitForSingleObject(httpfile->pParam->hThread, 3000);
				}
				::CloseHandle(httpfile->pParam->hThread);
				httpfile->pParam->hThread = INVALID_HANDLE_VALUE;
				// Xbh̏I莞ԑ҂
				if(::WaitForSingleObject(pReceive->mt->m_hThread, 5000) != WAIT_OBJECT_0) {
					if(::TerminateThread(pReceive->mt->m_hThread, 0)) {
						::WaitForSingleObject(pReceive->mt->m_hThread, 3000);
					}
				}
			}
			// CWinThreadIuWFNg̍폜
			delete pReceive->mt;
			delete pReceive;
			pReceive = NULL;
			// end pl3

			if (httpfile != NULL) {
				httpfile->Close();
				// begin pl2 by YunaSoft
				httpfile->Quit();
//				delete httpfile;
				// end pl2
				httpfile = NULL;
			}

			if (session != NULL) {
				session->Close();
				// begin pl2 by YunaSoft
				delete session;
				// end pl2
				// begin pl3 by YunaSoft
				DeleteAsyncSocket();
				// end pl3
				session = NULL;
			}

			return 1;
		}
	} else {
		mod.is_seekable = 1;

		if (!getmp3info(fn,&cur_mp3info,&current_id3,&current_vbrtag)) return 1;

		input_file = new FileSys(2);
		if(input_file->Open(
						prm->m_bFullBuffering ?
							FILESYS_OPENMODE_FULLBUFFERING : FILESYS_OPENMODE_NORMAL,
						fn, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL,
						OPEN_EXISTING,
						FILE_ATTRIBUTE_NORMAL | FILE_FLAG_SEQUENTIAL_SCAN) == false) {
			delete input_file;
			input_file = NULL;

			return 1;
		}

		file_length = cur_mp3info.nbytes;

		maxlatency = mod.outMod->Open(cur_mp3info.freq, cur_mp3info.nch, m_nOutputBps, -1, -1);

		if(maxlatency < 0) // error opening device
		{
			delete input_file;
			input_file = NULL;

			return 1;
		}

		input_file->SetPointer(IN_MPG123D_FILESYS_NO, cur_mp3info.hpos);
		g_adrTime.Init(input_file, cur_mp3info.hpos);
	}

	strcpy(lastfn,fn);
	decode_pos_ms=0;
	paused=0;
	seek_needed=-1;
	m_ssize = 576 * cur_mp3info.nch * (m_OutputBps >> 3);

	mod.SetInfo(cur_mp3info.bitrate/1000,cur_mp3info.freq/1000,cur_mp3info.nch,1);

	// initialize vis stuff
	mod.SAVSAInit(maxlatency,cur_mp3info.freq);
	mod.VSASetInfo(cur_mp3info.freq,cur_mp3info.nch);

	// set the output plug-ins default volume
	mod.outMod->SetVolume(-666);
	
	// begin pl3 by YunaSoft
	// [JXbh쐬Jn
	pDecode = new THREADPARAM;
	pDecode->kill = FALSE;
	pDecode->param = prm;

/*
	pDecode->mt = AfxBeginThread(DecodeThread, pDecode,
							prm->GetPriorityValue(prm->m_nDecodeThreadPriority));
	pDecode->mt->m_bAutoDelete = FALSE;
*/

	unsigned int	dwThread;

	pDecode->Thread = reinterpret_cast<HANDLE>(_beginthreadex(
							NULL, 0, DecodeThread, pDecode,
							CREATE_SUSPENDED, &dwThread));

	if(pDecode->Thread) {
		::SetThreadPriority(pDecode->Thread,
								prm->GetPriorityValue(prm->m_nDecodeThreadPriority));
		::ResumeThread(pDecode->Thread);
	} else {
		delete input_file;
		input_file = NULL;

		return 1;
	}

	// Xbh
//	pDecode->mt->SetThreadPriority(prm->GetPriorityValue(prm->m_nDecodeThreadPriority));
	// end pl3

	return 0;
}

void stop() { 
	// begin pl3 by YunaSoft / ot13 by Otachan
	if(pReceive) {
		pReceive->kill = TRUE;
		// Xbh̏I莞ԑ҂
		if(::WaitForSingleObject(pReceive->mt->m_hThread, 5000) != WAIT_OBJECT_0) {
			// Ō̎i
			// 莞ԑ҂ĂIȂƂ́AInternetReadFile API
			// ubNĂƔfAYAPI񂵂ĂXbĥ
			// ނ TerminateThread ĎMXbh̏I҂
			::MessageBox(mod.hMainWindow, "error asking receive thread to die!", "error killing receive thread", MB_OK);
			if(::TerminateThread(httpfile->pParam->hThread, 0)) {
				::WaitForSingleObject(httpfile->pParam->hThread, 3000);
			}
			::CloseHandle(httpfile->pParam->hThread);
			httpfile->pParam->hThread = INVALID_HANDLE_VALUE;
			// Xbh̏I莞ԑ҂
			if(::WaitForSingleObject(pReceive->mt->m_hThread, 5000) != WAIT_OBJECT_0) {
				if(::TerminateThread(pReceive->mt->m_hThread, 0)) {
					::WaitForSingleObject(pReceive->mt->m_hThread, 3000);
				}
			}
		}
		// CWinThreadIuWFNg̍폜
		delete pReceive->mt;
		delete pReceive;
		pReceive = NULL;
	}
	// end pl3

#if 1
	if (httpfile != NULL)
	{
		httpfile->Close();
		// begin pl2 by YunaSoft
		httpfile->Quit();
		// end pl2
//		delete httpfile;
		httpfile = NULL;
	}
#endif

	if (session != NULL)
	{
		session->Close();
		// begin pl1 by YunaSoft
		delete session;
		// begin pl3 by YunaSoft
		DeleteAsyncSocket();
		// end pl3
		session = NULL;
		// end pl1
		httpfile = NULL;
	}

	// begin pl3 by YunaSoft
	prm->m_icy.DeleteHeader();
	// end pl3

	// begin pl3 by YunaSoft / ot13 by Otachan
	if(pDecode) {
		pDecode->kill = TRUE;

/*
		if(::WaitForSingleObject(pDecode->mt->m_hThread, 5000) != WAIT_OBJECT_0) {
			if(::TerminateThread(pDecode->mt->m_hThread, 0)) {
				::WaitForSingleObject(pDecode->mt->m_hThread, 3000);
			}
		}
		delete pDecode->mt;
*/

		if(::WaitForSingleObject(pDecode->Thread, 5000) != WAIT_OBJECT_0) {
			if(::TerminateThread(pDecode->Thread, 0)) {
				::WaitForSingleObject(pDecode->Thread, 3000);
			}
		}
		::CloseHandle(pDecode->Thread);
		delete pDecode;
		pDecode = NULL;
	}
	// end pl3

	g_adrTime.Release();

	if(input_file) {
		delete input_file;
		input_file = NULL;
	}

	mod.outMod->Close();

	mod.SAVSADeInit();
}

int genre_last=147;
char *genre_list[]={
	"Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk",
	"Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies",
	"Other", "Pop", "R&B", "Rap", "Reggae", "Rock",
	"Techno", "Industrial", "Alternative", "Ska", "Death Metal", "Pranks",
	"Soundtrack", "Euro-Techno", "Ambient", "Trip-Hop", "Vocal", "Jazz+Funk",
	"Fusion", "Trance", "Classical", "Instrumental", "Acid", "House",
	"Game", "Sound Clip", "Gospel", "Noise", "AlternRock", "Bass",
	"Soul", "Punk", "Space", "Meditative", "Instrumental Pop", "Instrumental Rock",
	"Ethnic", "Gothic", "Darkwave", "Techno-Industrial", "Electronic", "Pop-Folk",
	"Eurodance", "Dream", "Southern Rock", "Comedy", "Cult", "Gangsta",
	"Top 40", "Christian Rap", "Pop/Funk", "Jungle", "Native American", "Cabaret",
	"New Wave", "Psychadelic", "Rave", "Showtunes", "Trailer", "Lo-Fi",
	"Tribal", "Acid Punk", "Acid Jazz", "Polka", "Retro", "Musical",
	"Rock & Roll", "Hard Rock", "Folk", "Folk/Rock", "National Folk", "Swing",
	"Fast-Fusion", "Bebob", "Latin", "Revival", "Celtic", "Bluegrass", "Avantgarde",
	"Gothic Rock", "Progressive Rock", "Psychedelic Rock", "Symphonic Rock", "Slow Rock", "Big Band",
	"Chorus", "Easy Listening", "Acoustic", "Humour", "Speech", "Chanson",
	"Opera", "Chamber Music", "Sonata", "Symphony", "Booty Bass", "Primus",
	"Porn Groove", "Satire", "Slow Jam", "Club", "Tango", "Samba",
	"Folklore", "Ballad", "Power Ballad", "Rhythmic Soul", "Freestyle", "Duet",
	"Punk Rock", "Drum Solo", "A capella", "Euro-House", "Dance Hall",
	"Goa", "Drum & Bass", "Club House", "Hardcore", "Terror",
	"Indie", "BritPop", "NegerPunk", "Polsk Punk", "Beat",
	"Christian Gangsta", "Heavy Metal", "Black Metal", "Crossover", "Contemporary C",
	"Christian Rock", "Merengue", "Salsa", "Thrash Metal", "Anime", "JPop",
	"SynthPop",
};

#define TITLEBUFLEN (MAX_PATH-10)


int gettitlefromid3(id3tag *tag,char *filename,char *title)
{
	// begin pl3 by YunaSoft
	const char *p;
	// end pl3
	char *q,*r,/**s,*/buf[31];
	int remain = TITLEBUFLEN;
	int		StrLen;

	// added by Otachan
	if(GetTitleFromID3v2(filename, title, (LPCTSTR)prm->m_strID3Format)) return 1;
	//

	// begin pl3 by YunaSoft
	if((prm->m_sif.m_file != "") && (prm->m_sif.m_title != "")) {
//		return prm->m_sif.GetTitleFromSIF(filename, title, (LPCTSTR)prm->m_strSIFFormat);
		return prm->m_sif.GetTitleFromSIF(filename, title, (LPCTSTR)prm->m_strID3Format);
	}
	// end pl3
	
	if (strncmp(tag->tag,"TAG",3) != 0) return 0;

	q = title;

	// begin pl3 by YunaSoft
	for(p = (LPCTSTR)prm->m_strID3Format;*p != '\0' && remain > 0;)
	// end pl3
	{
		if (*p != '%') {
			*q++ = *p++;
			remain--;
			continue;
		}

		switch(*++p)
		{
		case '%':
			*q++ = '%';
			remain--;
			break;
		case '1':
			strncpy(buf,tag->artist,30);
			buf[30] = '\0';
			for(r = buf;*r != '\0';r++) ;
			for(r--;r >= buf && *r == ' ';r--) ;
			*(r+1) = '\0';
			strncpy(q,buf,remain);
			remain -= strlen(buf);
			q += strlen(buf);
			break;
		case '2':
			strncpy(buf,tag->title,30);
			buf[30] = '\0';
			for(r = buf;*r != '\0';r++) ;
			for(r--;r >= buf && *r == ' ';r--) ;
			*(r+1) = '\0';
			strncpy(q,buf,remain);
			remain -= strlen(buf);
			q += strlen(buf);
			break;
		case '3':
			strncpy(buf,tag->album,30);
			buf[30] = '\0';
			for(r = buf;*r != '\0';r++) ;
			for(r--;r >= buf && *r == ' ';r--) ;
			*(r+1) = '\0';
			strncpy(q,buf,remain);
			remain -= strlen(buf);
			q += strlen(buf);
			break;
		case '4':
			strncpy(buf,tag->year,4);
			buf[4] = '\0';
			for(r = buf;*r != '\0';r++) ;
			for(r--;r >= buf && *r == ' ';r--) ;
			*(r+1) = '\0';
			strncpy(q,buf,remain);
			remain -= strlen(buf);
			q += strlen(buf);
			break;
		case '5':
			strncpy(buf,tag->comment,30);
			buf[30] = '\0';
			for(r = buf;*r != '\0';r++) ;
			for(r--;r >= buf && *r == ' ';r--) ;
			*(r+1) = '\0';
			strncpy(q,buf,remain);
			remain -= strlen(buf);
			q += strlen(buf);
			break;
		case '6':
			if (tag->genre > genre_last) {
				strncpy(q,"unknown",remain);
				remain -= 7;
				q += 7;
				break;
			}
			strncpy(q,genre_list[tag->genre],remain);
			remain -= strlen(genre_list[tag->genre]);
			q += strlen(genre_list[tag->genre]);
			break;
		case '7':
			{
				char	Name[MAX_PATH];
				char	NameOnly[MAX_PATH];

				CutPathFileName(filename, NULL, Name);
				CutFileNameExt(Name, NameOnly, NULL);
				Strncpy(q, NameOnly, remain);
				StrLen = strlen(NameOnly);
				remain -= StrLen;
				q += StrLen;
			}
/*
			r=s=filename+strlen(filename);
			while (*r != '\\' && r >= filename) r--;
			r++;
			while (*s != '.'  && s >= filename) s--;
			if (s < r) s = filename+strlen(filename);
			while(r < s && remain > 0) {
				*q++ = *r++;
				remain--;
			}
*/
			break;
		case '8':
			{
				char	Path[MAX_PATH];

				CutPathFileName(filename, Path, NULL);
				Strncpy(q, Path, remain);
				StrLen = strlen(Path);
				remain -= StrLen;
				q += StrLen;
			}
/*
			s=filename+strlen(filename);
			while (*s != '\\' && s >= filename) s--;
			if (*s == '\\') s++;
			r = filename;
			while(r < s && remain > 0) {
				*q++ = *r++;
				remain--;
			}
*/
			break;
		case '9':
			{
				char	Ext[MAX_PATH];

				CutFileNameExt(filename, NULL, Ext);
				Strncpy(q, Ext, remain);
				StrLen = strlen(Ext);
				remain -= StrLen;
				q += StrLen;
			}
/*
			r=s=filename+strlen(filename);
			while (*r != '\\' && r >= filename) r--;
			while (*s != '.'  && s >= filename) s--;
			if (s < r) s = filename+strlen(filename);
			while(*s != '\0' && remain > 0) {
				*q++ = *s++;
				remain--;
			}
*/
			break;
		case 'a':
		case 'b':
		case 'c':
		case 'd':
		case 'e':
			break;
		default:
			if (remain >= 1) { *q++ = '%'; remain--; }
			if (remain >= 1) { *q++ = *p;  remain--; }
			break;
		}

		p++;
	}

	*q = '\0';
	
	return 1;
}

void getfileinfo(char *filename, char *title, int *length_in_ms)
{
	if (!filename || !*filename)
	{
		// currently playing file
		if (length_in_ms) {
			if (cur_mp3info.isStream) {
				*length_in_ms = -1000;
			} else {
				*length_in_ms = (int)(cur_mp3info.length*1000);
			}
		}

		if (title) 
		{
			// begin pl1 by YunaSoft
			if (cur_mp3info.isStream) {
				char buf[TITLEBUFLEN], dst[TITLEBUFLEN];
				// begin pl3 by YunaSoft
				wsprintf(buf, "%s (%s)", (LPCTSTR)prm->m_icy.m_title, (LPCTSTR)prm->m_icy.m_name);
				if(prm->m_bTitleStreamingDecode) {
					prm->URLDecode(buf, dst);
				}
				// end pl3
				strncpy(title, dst, TITLEBUFLEN);

			} else 
			// end pl1
			{
				if (!gettitlefromid3(&current_id3,lastfn,title)) {
					char	Name[MAX_PATH];

					CutPathFileName(lastfn, NULL, Name);
					CutFileNameExt(Name, title, NULL);
				}
			}
			PostMessage(mod.hMainWindow, WM_WA_MPG123_IPC, 0, 0xf3);
		}
	}
	else
	{
		// some other file
		mp3info info;
		id3tag id3;
		VBRTAGDATA vbr;
		
		if (getmp3info(filename,&info,&id3,&vbr)) {
			if (length_in_ms) 
			{
				*length_in_ms = (int)(info.length*1000);
			}
			if (title) 
			{
				if (!gettitlefromid3(&id3,filename,title)) {
/*
					char *p=filename+strlen(filename);
					while (*p != '\\' && p >= filename) p--;
					strncpy(title,++p,TITLEBUFLEN);
*/
					char	Name[MAX_PATH];

					CutPathFileName(filename, NULL, Name);
					CutFileNameExt(Name, title, NULL);
				}
				PostMessage(mod.hMainWindow, WM_WA_MPG123_IPC, 0, 0xf3);
			}
		} else {
			// not MP3 file
			if (length_in_ms) 
			{
				*length_in_ms = 0;
			}
			if (title) 
			{
/*
				char *p=filename+strlen(filename);
				while (*p != '\\' && p >= filename) p--;
				strncpy(title,++p,TITLEBUFLEN);
*/
				CutPathFileName(filename, NULL, title);
				PostMessage(mod.hMainWindow, WM_WA_MPG123_IPC, 0, 0xf3);
			}
		}
	}


}

// Decoding thread

#define OBSIZE 65536
#define FBSIZE 512

static char obuf[OBSIZE];
static int bstart,bend;
static struct mpstr mp;
static int decoder_stat;

inline void
Sample_Int24toInt16(char* OutBuff, char* InBuff, const int Size)
{
	short*	OutBuff_ = reinterpret_cast<short*>(OutBuff);

	for(int Idx = 1; Idx < Size; Idx += 3) {
		*OutBuff_++ = *reinterpret_cast<short*>(InBuff + Idx);
	}
}

inline void
Sample_Int32toInt16(char* OutBuff, char* InBuff, const int Size)
{
	short*	OutBuff_ = reinterpret_cast<short*>(OutBuff);

	for(int Idx = 2; Idx < Size; Idx += 4) {
		*OutBuff_++ = *reinterpret_cast<short*>(InBuff + Idx);
	}
}

inline void
Sample_Float32toInt16(char* OutBuff, char* InBuff, const int Size)
{
	short*	OutBuff_ = reinterpret_cast<short*>(OutBuff);

	for(int Idx = 0; Idx < Size; Idx += 4) {
		int		v = static_cast<int>
								(*reinterpret_cast<float*>(InBuff + Idx) * 0x7fff);

		if(v > 0x7fff) {
			v = 0x7fff;
		} else if(v < -0x8000) {
			v = -0x8000;
		}

		*OutBuff_++ = v;
	}
}

inline void
Sample_Float64toInt16(char* OutBuff, char* InBuff, const int Size)
{
	short*	OutBuff_ = reinterpret_cast<short*>(OutBuff);

	for(int Idx = 0; Idx < Size; Idx += 8) {
		int		v = static_cast<int>
								(*reinterpret_cast<double*>(InBuff + Idx) * 0x7fff);

		if(v > 0x7fff) {
			v = 0x7fff;
		} else if(v < -0x8000) {
			v = -0x8000;
		}

		*OutBuff_++ = v;
	}
}

inline void	PostProcStereoInt16(char* Buff, const int Size);
inline void	PostProcStereoInt24(char* Buff, const int Size);
inline void	PostProcStereoInt32(char* Buff, const int Size);
inline void	PostProcStereoFloat32(char* Buff, const int Size);
inline void	PostProcStereoFloat64(char* Buff, const int Size);
inline void	PostProcMonoInt16(char* Buff, const int Size);
inline void	PostProcMonoInt24(char* Buff, const int Size);
inline void	PostProcMonoInt32(char* Buff, const int Size);
inline void	PostProcMonoFloat32(char* Buff, const int Size);
inline void	PostProcMonoFloat64(char* Buff, const int Size);

inline void
PostProc(char* Buff, int Size)
{
	if(cur_mp3info.nch == 2) {
		switch(m_OutputBps) {
		case 16:
			PostProcStereoInt16(Buff, Size);
			break;
		case 24:
			PostProcStereoInt24(Buff, Size);
			break;
		case 32:
			switch(m_Format) {
			case DATA_FORMAT_LINEAR_PCM:
				PostProcStereoInt32(Buff, Size);
				break;
			case DATA_FORMAT_IEEE_FLOAT:
				PostProcStereoFloat32(Buff, Size);
				break;
			}
			break;
		case 64:
			PostProcStereoFloat64(Buff, Size);
			break;
		}
	} else if(prm->m_bInvert || prm->m_bAltVolume) {
		switch(m_OutputBps) {
		case 16:
			PostProcMonoInt16(Buff, Size);
			break;
		case 24:
			PostProcMonoInt24(Buff, Size);
			break;
		case 32:
			switch(m_Format) {
			case DATA_FORMAT_LINEAR_PCM:
				PostProcMonoInt32(Buff, Size);
				break;
			case DATA_FORMAT_IEEE_FLOAT:
				PostProcMonoFloat32(Buff, Size);
				break;
			}
			break;
		case 64:
			PostProcMonoFloat64(Buff, Size);
			break;
		}
	}
}

inline void
PostProcStereoInt16(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bReverse = prm->m_bReverse != 0;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 2;
	const int	AddIdx = Bps * 2;

	for(int Idx = 0; Idx < Size; Idx += AddIdx) {
		char*	IdxBuff = Buff + Idx;
		short*	l = reinterpret_cast<short*>(IdxBuff);
		short*	r = reinterpret_cast<short*>(IdxBuff + Bps);

		if(bReverse) Swap(l, r);

		if(bInvert) {
			*l = (*l == -0x8000) ? 0x7fff : -*l;
			*r = (*r == -0x8000) ? 0x7fff : -*r;
		}

		if(bAltVolume) {
			const int	pl = prm->m_nPan > 0 ? 127 - prm->m_nPan : 127;
			const int	pr = prm->m_nPan < 0 ? 127 + prm->m_nPan : 127;

			*l = nVolume * pl * static_cast<int>(*l) / (255 * 127);
			*r = nVolume * pr * static_cast<int>(*r) / (255 * 127);
		}
	}
}

inline void
PostProcStereoInt24(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bReverse = prm->m_bReverse != 0;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 3;
	const int	AddIdx = Bps * 2;

	for(int Idx = 0; Idx < Size; Idx += AddIdx) {
		unsigned char*	IdxBuff = reinterpret_cast<unsigned char*>(Buff) + Idx;

		if(bReverse) Swap3bytes(IdxBuff, IdxBuff + 3);

		if(bInvert || bAltVolume) {
			int		l = Int24ToInt32(IdxBuff);
			int		r = Int24ToInt32(IdxBuff + 3);

			if(bInvert) {
				l = (l == -0x800000) ? 0x7fffff : -l;
				r = (r == -0x800000) ? 0x7fffff : -r;
			}

			if(bAltVolume) {
				const int	pl = prm->m_nPan > 0 ? 127 - prm->m_nPan : 127;
				const int	pr = prm->m_nPan < 0 ? 127 + prm->m_nPan : 127;

				l = static_cast<int>
							(nVolume * pl * static_cast<__int64>(l) / (255 * 127));
				r = static_cast<int>
							(nVolume * pr * static_cast<__int64>(r) / (255 * 127));
			}

			Memcpy3bytes(IdxBuff, reinterpret_cast<unsigned char*>(&l));
			Memcpy3bytes(IdxBuff + 3, reinterpret_cast<unsigned char*>(&r));
		}
	}
}

inline void
PostProcStereoInt32(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bReverse = prm->m_bReverse != 0;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 4;
	const int	AddIdx = Bps * 2;

	for(int Idx = 0; Idx < Size; Idx += AddIdx) {
		char*	IdxBuff = Buff + Idx;
		int*	l = reinterpret_cast<int*>(IdxBuff);
		int*	r = reinterpret_cast<int*>(IdxBuff + Bps);

		if(bReverse) Swap(l, r);

		if(bInvert) {
			*l = (*l == -static_cast<int>(0x80000000)) ? 0x7fffffff : -*l;
			*r = (*r == -static_cast<int>(0x80000000)) ? 0x7fffffff : -*r;
		}

		if(bAltVolume) {
			const int	pl = prm->m_nPan > 0 ? 127 - prm->m_nPan : 127;
			const int	pr = prm->m_nPan < 0 ? 127 + prm->m_nPan : 127;

			*l = static_cast<int>
						(nVolume * pl * static_cast<__int64>(*l) / (255 * 127));
			*r = static_cast<int>
						(nVolume * pr * static_cast<__int64>(*r) / (255 * 127));
		}
	}
}

inline void
PostProcStereoFloat32(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bReverse = prm->m_bReverse != 0;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 4;
	const int	AddIdx = Bps * 2;

	for(int Idx = 0; Idx < Size; Idx += AddIdx) {
		char*	IdxBuff = Buff + Idx;
		float*	l = reinterpret_cast<float*>(IdxBuff);
		float*	r = reinterpret_cast<float*>(IdxBuff + Bps);

		if(bReverse) Swap(l, r);

		if(bInvert) {
			*l *= -1;
			*r *= -1;
		}

		if(bAltVolume) {
			const int	pl = prm->m_nPan > 0 ? 127 - prm->m_nPan : 127;
			const int	pr = prm->m_nPan < 0 ? 127 + prm->m_nPan : 127;

			*l = nVolume * pl * *l / (255 * 127);
			*r = nVolume * pr * *r / (255 * 127);
		}
	}
}

inline void
PostProcStereoFloat64(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bReverse = prm->m_bReverse != 0;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 8;
	const int	AddIdx = Bps * 2;

	for(int Idx = 0; Idx < Size; Idx += AddIdx) {
		char*	IdxBuff = Buff + Idx;
		double*	l = reinterpret_cast<double*>(IdxBuff);
		double*	r = reinterpret_cast<double*>(IdxBuff + Bps);

		if(bReverse) Swap(l, r);

		if(bInvert) {
			*l *= -1;
			*r *= -1;
		}

		if(bAltVolume) {
			const int	pl = prm->m_nPan > 0 ? 127 - prm->m_nPan : 127;
			const int	pr = prm->m_nPan < 0 ? 127 + prm->m_nPan : 127;

			*l = nVolume * pl * *l / (255 * 127);
			*r = nVolume * pr * *r / (255 * 127);
		}
	}
}

inline void
PostProcMonoInt16(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 2;

	for(int Idx = 0; Idx < Size; Idx += Bps) {
		short*	p = reinterpret_cast<short*>(Buff + Idx);

		if(bInvert) {
			*p = (*p == -0x8000) ? 0x7fff : -*p;
		}

		if(bAltVolume) {
			*p = nVolume * static_cast<int>(*p) / 255;
		}
	}
}

inline void
PostProcMonoInt24(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 3;

	for(int Idx = 0; Idx < Size; Idx += Bps) {
		unsigned char*	IdxBuff = reinterpret_cast<unsigned char*>(Buff) + Idx;
		int		p = Int24ToInt32(IdxBuff);

		if(bInvert) {
			p = (p == -0x800000) ? 0x7fffff : -p;
		}

		if(bAltVolume) {
			p = static_cast<int>(nVolume * static_cast<__int64>(p) / 255);
		}

		Memcpy3bytes(IdxBuff, reinterpret_cast<unsigned char*>(&p));
	}
}

inline void
PostProcMonoInt32(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 4;

	for(int Idx = 0; Idx < Size; Idx += Bps) {
		int*	p = reinterpret_cast<int*>(Buff + Idx);

		if(bInvert) {
			*p = (*p == -static_cast<int>(0x80000000)) ? 0x7fffffff : -*p;
		}

		if(bAltVolume) {
			*p = static_cast<int>(nVolume * static_cast<__int64>(*p) / 255);
		}
	}
}

inline void
PostProcMonoFloat32(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 4;

	for(int Idx = 0; Idx < Size; Idx += Bps) {
		float*	p = reinterpret_cast<float*>(Buff + Idx);

		if(bInvert) {
			*p *= -1;
		}

		if(bAltVolume) {
			*p = nVolume * *p / 255;
		}
	}
}

inline void
PostProcMonoFloat64(char* Buff, const int Size)
{
	const int	nVolume = prm->m_nVolume;
	const bool	bInvert = prm->m_bInvert != 0;
	const bool	bAltVolume = prm->m_bAltVolume != 0;

	const int	Bps = 8;

	for(int Idx = 0; Idx < Size; Idx += Bps) {
		double*	p = reinterpret_cast<double*>(Buff + Idx);

		if(bInvert) {
			*p *= -1;
		}

		if(bAltVolume) {
			*p = nVolume * *p / 255;
		}
	}
}

/*
void postproc(char *buf,int size)
{
	int Bps = 2;

	// begin pl3 by YunaSoft
	if (!prm->m_bReverse && !prm->m_bInvert && !prm->m_bAltVolume) return;
	// end pl3
	
	if (cur_mp3info.nch == 2) {
		int i;
		int pl=127,pr=127;
		// begin pl3 by YunaSoft
		if (prm->m_nPan > 0) pl = 127 - prm->m_nPan;
		if (prm->m_nPan < 0) pr = 127 + prm->m_nPan;
		// end pl3

		for(i=0;i<size/2/Bps;i++)
		{
			short *l = (short *)&buf[i*4],*r = (short *)&buf[i*4+2];

			// begin pl3 by YunaSoft
			if (prm->m_bReverse) {
			// end pl3
				short s;
				s = *l; *l = *r; *r = s;
			}
		
			// begin pl3 by YunaSoft
			if (prm->m_bInvert) {
			// end pl3
				*l = *l == -32768 ? 32767 : -*l; *r = *r == -32768 ? 32767 : -*r;
			}

			// begin pl3 by YunaSoft
			if (prm->m_bAltVolume) {
				*l = prm->m_nVolume*pl*(int)*l/(255*127);
				*r = prm->m_nVolume*pr*(int)*r/(255*127);
			}
			// end pl3
		}
	} else if (cur_mp3info.nch == 1) {
		int i;
		for(i=0;i<size/Bps;i++)
		{
			short *p = (short *)&buf[i*2];

			// begin pl3 by YunaSoft
			if (prm->m_bInvert) {
				*p = *p == -32768 ? 32767 : -*p;
			}

			if (prm->m_bAltVolume) {
				*p = prm->m_nVolume*(int)*p/255;
			}
			// end pl3
		}
	}
}
*/

void preload_stream(void)
{
	for(;;)
	{
		Sleep(200);
		int l = strbufp_s > strbufp_e ? strbuflen+strbufp_e-strbufp_s : strbufp_e-strbufp_s;
		if (l > strbuflen*7/8 || strbuf_eof) break;
	}
}

int get_576_samples(char* out, int supZero, int flush)
{
	bool	at_eof = false;

	if(flush) {
		ExitMP3(&mp);
		InitMP3(&mp, m_Format, m_OutputBps);
		bstart = 0;
		bend = 0;
		decoder_stat = MP3_NEED_MORE;
	}

	while((at_eof == false) && (m_ssize > (bend - bstart))) {
		if(bstart) {
			memmove(obuf, obuf + bstart, bend - bstart);
			bend -= bstart;
			bstart = 0;
		}

		int		size;

		if(decoder_stat != MP3_ERR) {
			DWORD	len;
			char*	in_buf;
			char	buf[FBSIZE];

			if(decoder_stat == MP3_NEED_MORE) {
				if(cur_mp3info.isStream) {
					len = 0;

					if(strbufp_s > strbufp_e) {
						if(strbuflen-strbufp_s > FBSIZE) {
							memcpy(buf, stream_buffer + strbufp_s, FBSIZE);
							strbufp_s += FBSIZE;
							len = FBSIZE;
						} else {
							memcpy(buf, stream_buffer + strbufp_s, strbuflen - strbufp_s);
							len = strbuflen-strbufp_s;
							strbufp_s = 0;
						}
					}

					if(strbufp_s < strbufp_e) {
						if(strbufp_e-strbufp_s > (int)(FBSIZE-len)) {
							memcpy(buf + len, stream_buffer + strbufp_s, FBSIZE - len);
							strbufp_s += FBSIZE - len;
							len = FBSIZE;
						} else {
							memcpy(buf+len, stream_buffer + strbufp_s, strbufp_e - strbufp_s);
							len += strbufp_e - strbufp_s;
							strbufp_s = strbufp_e;
						}
					}

					if(len == 0) preload_stream();

					at_eof = strbufp_e == strbufp_s && strbuf_eof;
				} else {
					input_file->Read(IN_MPG123D_FILESYS_NO, buf,
							Min(cur_mp3info.hpos + cur_mp3info.nbytes -
								input_file->GetPointer(IN_MPG123D_FILESYS_NO),
								(DWORD)FBSIZE),
							&len);
					at_eof = len == 0;
				}

				in_buf = buf;
			} else {
				len = 0;
				in_buf = NULL;
			}

			if(at_eof == false) {
				decoder_stat = decodeMP3(&mp, in_buf, len,
											obuf + bend, OBSIZE - bend, &size);
			}
		}

		if(decoder_stat == MP3_OK) {
			bend += size;
		} else if(decoder_stat == MP3_ERR) {
//			MessageBox(NULL,errorstring,"Decoder error",MB_OK);
			if((bend - bstart) == 0) return -1;
			at_eof = true;
		}

		if(supZero) {
			const int	nch = cur_mp3info.nch;
			const int	Bps = m_OutputBps >> 3;
			int		p, q, c;

			for(p = bstart; p < bend; p += Bps * nch)
				for(c=0; c < nch; c++)
					for(q=0; q < Bps; q++)
						if (obuf[p + c * Bps + q] != 0) goto BreakSupLoop;
			BreakSupLoop:

			if(p < bend) {
				bstart = p;
				supZero = 0;
			} else {
				bend = bstart;
			}
		}
	}

	char*	OutBuff = obuf + bstart;
	int		CopySize = Min(bend - bstart, m_ssize);

	bstart += CopySize;

	if(prm->m_bPostProc) PostProc(OutBuff, CopySize);

	memcpy(out, OutBuff, CopySize);

	return CopySize;
}

bool
SearchStream(unsigned int offs)
{
	bool	RetCode = false;
	const unsigned int	MaxSearch = 65536;
	unsigned int	SearchEnd = cur_mp3info.hpos + cur_mp3info.nbytes - 4;

	for(unsigned int hpos = 0; hpos < MaxSearch; hpos++) {
		unsigned int	SeekPnt = offs + hpos;

		if(SeekPnt > SearchEnd) break;

		unsigned int	head;

		input_file->SetPointer(IN_MPG123D_FILESYS_NO, SeekPnt);
		input_file->Read(IN_MPG123D_FILESYS_NO, &head, 4);

		if(head_check2(BSwap(head), &cur_mp3info)) {
			input_file->SetPointer(IN_MPG123D_FILESYS_NO, SeekPnt);
			RetCode = true;
			break;
		}
	}

	return RetCode;
}

// begin pl2 by YunaSoft
//UINT DecodeThread(LPVOID pParam)
unsigned int __stdcall DecodeThread(LPVOID pParam)
// end pl2
{
	int done=0;
	int supZero = prm->m_bSupZero;
	int isStream = cur_mp3info.isStream;

	// begin pl2 by YunaSoft
    // THREADPARAM
	THREADPARAM* p = (THREADPARAM *)pParam;
	// end pl2

	decoder_in_use = 1;

//	mp.totalFramesize=0;
//	mp.nframe=0;
	
	InitMP3(&mp, m_Format, m_OutputBps);
	decoder_stat = MP3_NEED_MORE;
	bstart = 0;
	bend = 0;
	int Bps = m_OutputBps >> 3;
	int flush = 0;

	if (isStream) preload_stream();
	
	// begin pl2 by YunaSoft
	while (!p->kill)
//	while (! *((int *)b) ) 
	// end pl2
	{
		if (seek_needed != -1)
		{
			int offs;

			offs = g_adrTime.ToAddress(seek_needed) - cur_mp3info.hpos;
			if (offs >= 0)
				seek_needed = g_adrTime.ToTime(offs + cur_mp3info.hpos);
			else if (cur_mp3info.hasVbrtag) {
//			if (cur_mp3info.hasVbrtag) {
				offs = SeekPoint(current_vbrtag.toc,cur_mp3info.nbytes,seek_needed/(cur_mp3info.length*10));
			} else {
				int framesize = mp.totalFramesize/mp.nframe;
				double frameDuration = 576.0*(cur_mp3info.lsf?1:2)/cur_mp3info.freq;
				//double length = cur_mp3info.nbytes * 8 / cur_mp3info.bitrate;
				double length = cur_mp3info.nbytes*frameDuration/framesize;

				offs = (int)((double)cur_mp3info.nbytes * seek_needed / (length * 1000));
			}

			offs += cur_mp3info.hpos;
			decode_pos_ms = seek_needed;
			seek_needed=-1;
			done=0;
			mod.outMod->Flush((int)decode_pos_ms);
			flush = 1;

			if(SearchStream(offs) == false) done = 1;
		}

		if(done){
			// fR[hICobt@̓eׂď̂҂Ă
			mod.outMod->CanWrite();
			if (!mod.outMod->IsPlaying())
			{
				ExitMP3(&mp);
				PostMessage(mod.hMainWindow,WM_WA_MPEG_EOF,0,0);
				decoder_in_use = 0;

				_endthreadex(0);
			}
			Sleep(10);
		} else if(mod.outMod->CanWrite() >= ((576*cur_mp3info.nch*Bps)<<(mod.dsp_isactive()?1:0))) {
			// ʏ
			int l;
			l=get_576_samples(sample_buffer,supZero,flush);
			supZero = 0;
			flush = 0;
			if (l == -1) {
				if (!isStream) {
					if(SearchStream(input_file->GetPointer(IN_MPG123D_FILESYS_NO))) {
						decode_pos_ms = g_adrTime.ToTime(
										input_file->GetPointer(IN_MPG123D_FILESYS_NO));
						flush = 1;
					} else {
						done = 1;
					}
				} else {
					unsigned long head;
					int i;

					for(i=0;i<65536;i++)
					{
						while(!strbuf_eof && (strbufp_e+strbuflen-strbufp_s)%strbuflen < 4) Sleep(100);

						*(3+(char *)&head) = stream_buffer[(strbufp_s  )%strbuflen];
						*(2+(char *)&head) = stream_buffer[(strbufp_s+1)%strbuflen];
						*(1+(char *)&head) = stream_buffer[(strbufp_s+2)%strbuflen];
						*(0+(char *)&head) = stream_buffer[(strbufp_s+3)%strbuflen];

						if (strbuf_eof || head_check2(head,&cur_mp3info)) break;
						strbufp_s = (strbufp_s+1) % strbuflen;
					}

					if (i == 65536 || strbuf_eof) {
						done = 1;
					} else {
						flush = 1;
					}
				}
			} else if(l == 0) {
				done = 1;
			} else {
//				mod.SAAddPCMData((char *)sample_buffer,cur_mp3info.nch,Bps*8,(int)decode_pos_ms);
//				mod.VSAAddPCMData((char *)sample_buffer,cur_mp3info.nch,Bps*8,(int)decode_pos_ms);

				char*	VisData;

				switch(m_OutputBps) {
				case 16:
					VisData = sample_buffer;
					break;
				case 24:
					Sample_Int24toInt16(sample_16_buffer, sample_buffer, l);
					VisData = sample_16_buffer;
					break;
				case 32:
					switch(m_Format) {
					case DATA_FORMAT_LINEAR_PCM:
						Sample_Int32toInt16(sample_16_buffer, sample_buffer, l);
						VisData = sample_16_buffer;
						break;
					case DATA_FORMAT_IEEE_FLOAT:
						Sample_Float32toInt16(sample_16_buffer, sample_buffer, l);
						VisData = sample_16_buffer;
						break;
					}
					break;
				case 64:
					Sample_Float64toInt16(sample_16_buffer, sample_buffer, l);
					VisData = sample_16_buffer;
					break;
				}

				mod.SAAddPCMData(VisData, cur_mp3info.nch, 2 * 8,
										static_cast<int>(decode_pos_ms));
				mod.VSAAddPCMData(VisData, cur_mp3info.nch, 2 * 8,
										static_cast<int>(decode_pos_ms));

				decode_pos_ms+=(576*1000.0)/cur_mp3info.freq;
				if (mod.dsp_isactive()) l=mod.dsp_dosamples((short *)sample_buffer,l/cur_mp3info.nch/Bps,Bps*8,cur_mp3info.nch,cur_mp3info.freq)*(cur_mp3info.nch*Bps);
				mod.outMod->Write(sample_buffer,l);
			}
		} else {
			if (!cur_mp3info.hasVbrtag) {
				int framesize = mp.totalFramesize/mp.nframe;
				double frameDuration = 576.0*(cur_mp3info.lsf?1:2)/cur_mp3info.freq;
				//cur_mp3info.length = cur_mp3info.nbytes * 8 / cur_mp3info.bitrate;
				cur_mp3info.length = cur_mp3info.nbytes*frameDuration/framesize;
			}
			if (!prm->m_bDispAvg) {
				static int lastBitrate;
				if (lastBitrate != mp.currentBitrate) {
					mod.SetInfo(mp.currentBitrate,-1,-1,-1);
					lastBitrate = mp.currentBitrate;
				}
			}
			Sleep(20);
		}
	}
	ExitMP3(&mp);
	decoder_in_use = 0;

	_endthreadex(0);
	return 0;
}

#define READUNIT 1024

// begin pl2 by YunaSoft

/////////////////////////////////////////////////////////////////////////////
// CIn_mpg123dSession object

// In_mpg123d wants to use its own derivative of the CInternetSession class
// just so it can implement an OnStatusCallback() override.

CIn_mpg123dSession::CIn_mpg123dSession(LPCTSTR pstrAgent,
									   DWORD dwContext,
									   DWORD dwAccessType,
									   LPCTSTR pstrProxyName,
									   LPCTSTR pstrProxyBypass,
									   DWORD dwFlags) 
	: CInternetSession(pstrAgent, dwContext, dwAccessType, pstrProxyName,
									   pstrProxyBypass, dwFlags)
{

}

void CIn_mpg123dSession::OnStatusCallback(DWORD /* dwContext */, DWORD dwInternetStatus,
	LPVOID /* lpvStatusInfomration */, DWORD /* dwStatusInformationLen */)
{
	AFX_MANAGE_STATE( AfxGetAppModuleState( ) );
	if (dwInternetStatus == INTERNET_STATUS_CONNECTED_TO_SERVER) {
		int a = 0;
	}
}

#if 0
/////////////////////////////////////////////////////////////////////////////
// CIn_mpg123dException -- used if something goes wrong for us

// In_mpg123d will throw its own exception type to handle problems it might
// encounter while fulfilling the user's request.

IMPLEMENT_DYNCREATE(CIn_mpg123dException, CException)

CIn_mpg123dException::CIn_mpg123dException(int nCode)
	: m_nErrorCode(nCode)
{
}

void ThrowIn_mpg123dException(int nCode)
{
	CIn_mpg123dException* pEx = new CIn_mpg123dException(nCode);
	throw pEx;
}

#endif

BOOL CheckThread(HANDLE hThread)
{
	//o
	DWORD	dw;

	//Xbh͓Ă邩H
	if(::GetExitCodeThread(hThread, &dw)) {
		if(dw == STILL_ACTIVE) return TRUE;
	}

	return FALSE;
}

//////////////////////////////////////////////////////////////
// UDP
//
// CSocket DGRAMł̓oȋĈ
// CAsyncSocket g܂

BOOL CIn_mpg123dApp::InitInstance() 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}
	
	return CWinApp::InitInstance();
}

UINT CreateAsyncSocket(UINT nPort, UINT count)
{

	UINT i = 0;
	BOOL bFlag = FALSE;

	if(m_pAsyncSocket) delete m_pAsyncSocket;

	m_pAsyncSocket = (CIn_mpg123dAsyncSocket*)new CIn_mpg123dAsyncSocket();
	if(!m_pAsyncSocket) return 0;

	while ((i < count) && (!bFlag)){
		if (!m_pAsyncSocket->Create(nPort + i, SOCK_DGRAM, NULL)) {
			i++;
		} else {
			bFlag = TRUE;
		}
	}

	if(!bFlag) {
		delete m_pAsyncSocket;
		m_pAsyncSocket = NULL;
		return 0;
	}

	return nPort + i;
}

BOOL ConnectAsyncSocket(CString strAddress, UINT nPort)
{
	if (!m_pAsyncSocket->Connect(strAddress, nPort)) {
		delete m_pAsyncSocket;
		m_pAsyncSocket = NULL;
		return FALSE;
	}
	return TRUE;
}

// begin pl3 by YunaSoft
void DeleteAsyncSocket()
{
	if(m_pAsyncSocket) {
		delete m_pAsyncSocket;
		m_pAsyncSocket = NULL;
	}
}

void UpdateWinampDisplay()
{
	PostMessage(mod.hMainWindow, WM_USER, 0, 0xf3);
}

void ReceiveUDPMsg(char *src)
{
	if (prm->m_icy.m_udpport > 0) {
		prm->m_icy.m_title =  src;
		UpdateWinampDisplay();
	}
}

void UpdateUDPSocket(CString server, UINT nPort)
{
	// UDP󂯂
	DeleteAsyncSocket();
	CreateAsyncSocket(nPort, 1);
	ConnectAsyncSocket(server, nPort);
}
// end pl3

//////////////////////////////////////////////////////////////
// ReadStream
//
// httpfile->Read ɑウ ƎɃCv httpfile->ReadEx
// gĂ܂BIn_mpg123dHttpFile.cpp QƂĂ

// begin pl3 by YunaSoft
UINT ReadStream(char* src, UINT nCount)
{
	// Streamǂ
	return httpfile->ReadEx(src, nCount);
}
// end pl3

// begin pl2 by YunaSoft
//////////////////////////////////////////////////////////////
// ReceiveThread
//
// CreateThread ŏグThreadlibc̊֐̋ۏ؂
// Ȃ̂ŁAAfxBeginThread ŏグĂ܂

UINT ReceiveThread(LPVOID pParam)
//DWORD WINAPI __stdcall ReceiveThread(void *b)
// end pl2
{
	strbuf_eof = 0;
	CFileException fe;
	CFile* fp;
	char tmp[READUNIT * 2]; // StreamTextEŒǉǂݏôłQ{m

	// begin pl3 by YunaSoft
	fp = NULL;
	// end pl3

    // THREADPARAM
	THREADPARAM* p = (THREADPARAM *)pParam;

	// begin pl3 by YunaSoft
	// Streamt@CɗƂƂ͂Ȋ
	if(p->param->m_bSaveStream) {
		fp = new CFile;
		fp->Open(p->param->m_strSaveStream, CFile::modeCreate | CFile::modeWrite); 
	}
	// end pl3

	// begin pl2 by YunaSoft
//	while (! *((int *)b) ) 
	while (!p->kill)
	// end pl2
	{
		if (strbufp_e == strbuflen && strbufp_s != 0) strbufp_e = 0;

		if (strbufp_e != strbuflen && strbufp_e >= strbufp_s) {
			UINT len;
			int len2 = strbuflen-strbufp_e < READUNIT ? strbuflen-strbufp_e : READUNIT;
			
			// begin pl3 by YunaSoft
//			len = httpfile->Read(stream_buffer+strbufp_e,len2);
			len = ReadStream(tmp, len2);
			// get ICY info and remove streamtext
			len = p->param->m_icy.GetICYInfo(stream_buffer+strbufp_e, tmp, len);

			if(p->param->m_bSaveStream) {
				// open if fp was closed
				if(!fp) {
					fp = new CFile;
					fp->Open(p->param->m_strSaveStream, CFile::modeCreate | CFile::modeWrite); 
				}
				fp->Write(stream_buffer+strbufp_e, len);
			} else {
				// close if fp was opened
				if(fp) {
					fp->Flush();
					fp->Close();
					delete fp;
					fp = NULL;
				}
			}
			// end pl3

			strbufp_e += len;

			if (len == 0) {
				break;
			}
		} else if (!(strbufp_e == strbuflen-1 && strbufp_s == strbuflen) && strbufp_e < strbufp_s-1) {
			UINT len;
			int len2 = strbufp_s-strbufp_e-1 < READUNIT ? strbufp_s-strbufp_e-1 : READUNIT;

			// begin pl3 by YunaSoft
//			len = httpfile->Read(stream_buffer+strbufp_e,len2);
			len = ReadStream(tmp, len2);
			// get ICY info and remove streamtext
			len = p->param->m_icy.GetICYInfo(stream_buffer+strbufp_e, tmp, len);

			if(p->param->m_bSaveStream) {
				// open if fp was closed
				if(!fp) {
					fp = new CFile;
					fp->Open(p->param->m_strSaveStream, CFile::modeCreate | CFile::modeWrite); 
				}
				fp->Write(stream_buffer+strbufp_e, len);
			} else {
				// close if fp was opened
				if(fp) {
					fp->Flush();
					fp->Close();
					delete fp;
					fp = NULL;
				}
			}
			// end pl3

			strbufp_e += len;

			if (len == 0) {
				break;
			}
		} else {
			Sleep(200);
		}
	}

// begin pl3 by YunaSoft

	//	if(p->param->m_bSaveStream) {
		if(fp) {
			fp->Flush();
			fp->Close();
			delete fp;
			fp = NULL;
		}
	//}
// end pl3

	strbuf_eof = 1;
	return 0;
}

// begin pl5 by YunaSoft
//////////////////////////////////////////////////////////////
// InternetReadFile API@̎̂ăXbh
//
// 낢뎎Ă݂łǁAT[oStreamĂ
// SYNC/ASYNC/NO_WAITɊ֌WȂubLO݂Ȃ
// ŁAǂ悤ȂTerminateThreadŊOEĂ
// ܂(TerminateThreadŃ^[~l[gł悤CreateThread
// Ă܂)
// AȂłˁH(^^;

#if 0
DWORD WINAPI __stdcall InternetReadFileThread(LPVOID pParam)
{

    // THREADPARAM
	THREADPARAMINETREAD* p = (THREADPARAMINETREAD *)pParam;
	INTERNET_BUFFERS inetbuf;
	inetbuf.dwStructSize = sizeof(INTERNET_BUFFERS);

	while (!p->kill) {

		// RetrievetOONȂAPIR[
		if(p->retr) {

			inetbuf.Next = NULL;
			inetbuf.lpcszHeader = NULL;
			inetbuf.dwHeadersLength = NULL;
			inetbuf.dwHeadersTotal = NULL;
			inetbuf.lpvBuffer = p->lpvBuffer;
			inetbuf.dwBufferLength = p->dwBufferLength;
			inetbuf.dwBufferTotal = NULL;
			inetbuf.dwOffsetLow = NULL; 
			inetbuf.dwOffsetHigh = NULL;

			if (!InternetReadFile(m_hFile, (LPVOID) lpBuf, nCount, &dwBytes))
				AfxThrowInternetException(m_dwContext);

			if (InternetReadFile(p->hFile,
				p->lpvBuffer,
				p->dwBufferLength,
				p->dwBufferLength) {
			if (InternetReadFileEx(p->hFile,
				&inetbuf,
				NULL,
				NULL)) {
				p->dwBufferLength = inetbuf.dwBufferLength;
				p->success = TRUE;
			} else {
				p->success = FALSE;
			}
			p->retr = FALSE;
		}
		// TXyh
		SuspendThread(p->hThread);
	}

	return 0;
}
// end pl2
#endif

DWORD WINAPI __stdcall InternetReadFileThread(LPVOID pParam)
{

    // THREADPARAM
	THREADPARAMINETREAD* p = (THREADPARAMINETREAD *)pParam;

	while (!p->kill) {

		// RetrievetOONȂAPIR[
		if(p->retr) {

			if (InternetReadFile(p->hFile,
				p->lpvBuffer,
				p->nCount,
				&(p->dwBufferLength))) {
				p->success = TRUE;
			} else {
				p->success = FALSE;
			}
			p->retr = FALSE;
		}
		// TXyh
		SuspendThread(p->hThread);
	}

	return 0;
}
// end pl5



#if 0
void main(void)
{
}
#endif
#endif
